SystemOrganization addCategory: #'Metacello-Core'!
SystemOrganization addCategory: #'Metacello-Core-Constructors'!
SystemOrganization addCategory: #'Metacello-Core-Exceptions'!
SystemOrganization addCategory: #'Metacello-Core-Loaders'!
SystemOrganization addCategory: #'Metacello-Core-Members'!
SystemOrganization addCategory: #'Metacello-Core-Model'!
SystemOrganization addCategory: #'Metacello-Core-Specs'!
SystemOrganization addCategory: #'Metacello-Core-Validation'!

Notification subclass: #MetacelloCleanNotification
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

MetacelloCleanNotification subclass: #MetacelloCleanLoadAndTestsNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

MetacelloCleanNotification subclass: #MetacelloCleanLoadNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloCleanNotification class methodsFor: 'exceptioninstantiator' stamp: 'DaleHenrichs 11/21/2010 19:16'!
signal: aMetacelloVersion

	^ self new signal: aMetacelloVersion! !

!MetacelloCleanNotification methodsFor: 'signaling' stamp: 'DaleHenrichs 11/21/2010 19:16'!
signal: aMetacelloVersion

	self version: aMetacelloVersion.
	^ self signal! !

!MetacelloCleanNotification methodsFor: 'accessing' stamp: 'DaleHenrichs 11/21/2010 19:16'!
version
	^ version! !

!MetacelloCleanNotification methodsFor: 'accessing' stamp: 'DaleHenrichs 11/21/2010 19:16'!
version: anObject
	version := anObject! !

Notification subclass: #MetacelloClearStackCacheNotification
	instanceVariableNames: 'cacheNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloClearStackCacheNotification methodsFor: 'accessing' stamp: 'dkh 4/6/2011 23:14'!
cacheNames
	^ cacheNames! !

!MetacelloClearStackCacheNotification methodsFor: 'accessing' stamp: 'dkh 4/6/2011 23:14'!
cacheNames: anArray
	cacheNames := anArray! !

!MetacelloClearStackCacheNotification methodsFor: 'signaling' stamp: 'dkh 4/6/2011 23:15'!
signal: anArray
	"Signal the occurrence of an exceptional condition with a specified cacheName."

	self cacheNames: anArray.
	^ self signal! !

Notification subclass: #MetacelloSkipDirtyPackageLoad
	instanceVariableNames: 'packageSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloSkipDirtyPackageLoad class methodsFor: 'signalling' stamp: 'dkh 11/16/2011 10:12'!
signal: aMetacelloPackageSpec

	^(self new packageSpec: aMetacelloPackageSpec) signal! !

!MetacelloSkipDirtyPackageLoad methodsFor: 'accessing' stamp: 'dkh 11/16/2011 10:13'!
defaultAction
	"Default action is to skip the load of a dirty package"

	^true! !

!MetacelloSkipDirtyPackageLoad methodsFor: 'accessing' stamp: 'dkh 11/16/2011 10:10'!
packageSpec

	^packageSpec! !

!MetacelloSkipDirtyPackageLoad methodsFor: 'accessing' stamp: 'dkh 11/16/2011 10:10'!
packageSpec: aMetacelloPackageSpec

	packageSpec := aMetacelloPackageSpec! !

Notification subclass: #MetacelloStackCacheNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

Notification subclass: #MetacelloValidationNotification
	instanceVariableNames: 'issue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloValidationNotification class methodsFor: 'exceptioninstantiator' stamp: 'DaleHenrichs 11/4/2010 10:00'!
signal: aMetacelloValidationIssue

	^ self new signal: aMetacelloValidationIssue! !

!MetacelloValidationNotification methodsFor: 'accessing' stamp: 'DaleHenrichs 11/4/2010 10:01'!
issue
	^ issue! !

!MetacelloValidationNotification methodsFor: 'accessing' stamp: 'DaleHenrichs 11/4/2010 10:01'!
issue: anObject
	issue := anObject! !

!MetacelloValidationNotification methodsFor: 'signaling' stamp: 'DaleHenrichs 11/4/2010 10:01'!
signal: aMetacelloValidationIssue

	self issue: aMetacelloValidationIssue.
	^ self signal! !

!String methodsFor: '*metacello-core' stamp: 'dkh 06/03/2009 12:41'!
addToMetacelloPackages: aMetacelloPackagesSpec

	| spec |
	spec := 
		(aMetacelloPackagesSpec project packageSpec)
			file: self;
			yourself.
	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec addMember 
			name: spec name;
			spec: spec;
			yourself)! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/14/2009 09:31'!
asMetacelloVersionNumber

	^MetacelloVersionNumber fromString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 11:59'!
mergeIntoMetacelloPackages: aMetacelloPackagesSpec

	| spec |
	spec := 
		(aMetacelloPackagesSpec project packageSpec)
			file: self;
			yourself.
	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec mergeMember 
			name: spec name;
			spec: spec;
			yourself)
! !

!String methodsFor: '*metacello-core-version comparison' stamp: 'dkh 8/13/2009 12:04'!
metacelloIntegerLessThanSelf: anInteger
	"integer version components are always '>' string component"

	^false! !

!String methodsFor: '*metacello-core-version comparison' stamp: 'dkh 8/13/2009 11:23'!
metacelloStringLessThanSelf: aString

	^aString < self! !

!String methodsFor: '*metacello-core-version comparison' stamp: 'dkh 8/13/2009 11:22'!
metacelloVersionComponentLessThan: aMetacelloVersonComponent

	^aMetacelloVersonComponent metacelloStringLessThanSelf: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 11:59'!
removeFromMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec removeMember 
			name: self;
			yourself)! !

!String methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:13'!
setAuthorInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setAuthorWithString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 9/13/2009 07:45'!
setAuthorInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setAuthor: 
		(aMetacelloVersionSpec project valueHolderSpec
			value: self;
			yourself)! !

!String methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:10'!
setBlessingInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setBlessingWithString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/5/2009 11:48'!
setBlessingInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setBlessing: 
		(aMetacelloVersionSpec project valueHolderSpec
			value: self;
			yourself)! !

!String methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:14'!
setDescriptionInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setDescriptionWithString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/5/2009 11:51'!
setDescriptionInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setDescription: 
		(aMetacelloVersionSpec project valueHolderSpec
			value: self;
			yourself)! !

!String methodsFor: '*metacello-core' stamp: 'dkh 9/23/2009 08:46'!
setIncludesInMetacelloPackage: aMetacelloPackageSpec

	aMetacelloPackageSpec setIncludes: { self }.! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/8/2009 19:02'!
setLoadsInMetacelloProject: aMetacelloPackageSpec

	aMetacelloPackageSpec setLoads: { self }.! !

!String methodsFor: '*metacello-core' stamp: 'dkh 10/9/2009 11:28'!
setPackage: aString withInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setPackage: aString withString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 10/9/2009 11:16'!
setProject: aString withInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setProject: aString withString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 10:08'!
setRequiresInMetacelloPackage: aMetacelloPackageSpec

	aMetacelloPackageSpec setRequires: { self }.! !

!String methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:15'!
setTimestampInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setTimestampWithString: self! !

!String methodsFor: '*metacello-core' stamp: 'dkh 9/13/2009 07:47'!
setTimestampInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setTimestamp: 
		(aMetacelloVersionSpec project valueHolderSpec
			value: self;
			yourself)! !

!DateAndTime methodsFor: '*metacello-core' stamp: 'dkh 9/13/2009 07:49'!
setTimestampInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setTimestamp: 
		(aMetacelloVersionSpec project valueHolderSpec
			value: self printString;
			yourself)! !

!Symbol methodsFor: '*metacello-core' stamp: 'dkh 9/6/2012 10:03:17'!
asMetacelloAttributeList
    ^ {self}! !

!Symbol methodsFor: '*metacello-core' stamp: 'dkh 9/6/2012 10:03:17'!
asMetacelloAttributePath
    ^ MetacelloMethodSectionPath with: {self}! !

!Symbol methodsFor: '*metacello-core' stamp: 'dkh 9/5/2012 06:26:03.064'!
setForDo: aBlock withInMetacelloConfig: aMetacelloConstructore
    aMetacelloConstructore setFor: {self} do: aBlock! !

!Symbol methodsFor: '*metacello-core' stamp: 'dkh 9/5/2012 06:26:03.064'!
setForVersion: aString withInMetacelloConfig: aMetacelloConstructore
    aMetacelloConstructore setFor: {self} version: aString! !

!Symbol methodsFor: '*metacello-core' stamp: 'DaleHenrichs 12/21/2010 13:54'!
setPostLoadDoItInMetacelloSpec: aMetacelloSpec

	aMetacelloSpec setPostLoadDoIt: 
		(aMetacelloSpec project valueHolderSpec
			value: self;
			yourself)! !

!Symbol methodsFor: '*metacello-core' stamp: 'DaleHenrichs 12/21/2010 13:55'!
setPreLoadDoItInMetacelloSpec: aMetacelloSpec

	aMetacelloSpec setPreLoadDoIt: 
		(aMetacelloSpec project valueHolderSpec
			value: self;
			yourself)! !

Error subclass: #MetacelloCannotUpdateReleasedVersionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloCannotUpdateReleasedVersionError methodsFor: 'private' stamp: 'DaleHenrichs 12/20/2010 11:52'!
isResumable
	"Determine whether an exception is resumable."

	^ true! !

Error subclass: #MetacelloProjectSpecLoadError
	instanceVariableNames: 'projectSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

MetacelloProjectSpecLoadError subclass: #MetacelloProjectSpecLoadConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloProjectSpecLoadConflict methodsFor: 'private' stamp: 'DaleHenrichs 2/5/2010 16:16'!
isResumable
	"Determine whether an exception is resumable."

	^ true! !

!MetacelloProjectSpecLoadError class methodsFor: 'instance creation' stamp: 'DaleHenrichs 1/19/2010 11:28'!
projectSpec: aMetacelloMCProjectSpec

	^self new
		projectSpec: aMetacelloMCProjectSpec;
		yourself! !

!MetacelloProjectSpecLoadError methodsFor: 'private' stamp: 'DaleHenrichs 2/5/2010 16:18'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

!MetacelloProjectSpecLoadError methodsFor: 'accessing' stamp: 'DaleHenrichs 1/19/2010 11:29'!
projectSpec

	^projectSpec! !

!MetacelloProjectSpecLoadError methodsFor: 'accessing' stamp: 'DaleHenrichs 1/19/2010 11:29'!
projectSpec: aMetacelloMCProjectSpec

	projectSpec := aMetacelloMCProjectSpec! !

Error subclass: #MetacelloVersionDoesNotExistError
	instanceVariableNames: 'project versionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

MetacelloVersionDoesNotExistError subclass: #MetacelloSymbolicVersionDoesNotExistError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloSymbolicVersionDoesNotExistError methodsFor: 'printing' stamp: 'dkh 3/18/2011 15:00'!
description
	"Return a textual description of the exception."

	^'The symbolic version ', self versionString printString, ' is not defined in ', self project label, ' for the current platform.'! !

MetacelloSymbolicVersionDoesNotExistError subclass: #MetacelloSymbolicVersionNotDefinedError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Exceptions'!

!MetacelloSymbolicVersionNotDefinedError methodsFor: 'printing' stamp: 'dkh 3/18/2011 15:00'!
description
	"Return a textual description of the exception."

	^'The symbolic version ', self versionString printString, ' is EXPLICITLY not defined in ', self project label, ' for the current platform.'! !

!MetacelloVersionDoesNotExistError class methodsFor: 'instance creation' stamp: 'DaleHenrichs 9/24/2010 11:58'!
project: aMetacelloProject versionString: aVersionString

	^(self new)
		project: aMetacelloProject;
		versionString: aVersionString;
		yourself! !

!MetacelloVersionDoesNotExistError methodsFor: 'printing' stamp: 'DaleHenrichs 9/24/2010 12:01'!
description
	"Return a textual description of the exception."

	^'Version ', self versionString printString, ' is not defined in ', self project label! !

!MetacelloVersionDoesNotExistError methodsFor: 'accessing' stamp: 'DaleHenrichs 9/24/2010 11:57'!
project
	^ project! !

!MetacelloVersionDoesNotExistError methodsFor: 'accessing' stamp: 'DaleHenrichs 9/24/2010 11:57'!
project: anObject
	project := anObject! !

!MetacelloVersionDoesNotExistError methodsFor: 'accessing' stamp: 'DaleHenrichs 9/24/2010 11:46'!
versionString
	^ versionString! !

!MetacelloVersionDoesNotExistError methodsFor: 'accessing' stamp: 'DaleHenrichs 9/24/2010 11:46'!
versionString: anObject
	versionString := anObject! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'dkh 11/3/2009 10:28'!
asMetacelloVersionNumber

	^MetacelloVersionNumber fromString: ''! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'dkh 9/13/2009 07:46'!
setAuthorInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setAuthor: self! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'dkh 6/5/2009 10:56'!
setBlessingInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setBlessing: self! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'dkh 6/5/2009 11:52'!
setDescriptionInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setDescription: self! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'DaleHenrichs 12/21/2010 13:52'!
setPostLoadDoItInMetacelloSpec: aMetacelloSpec

	aMetacelloSpec setPostLoadDoIt: 
		(aMetacelloSpec project valueHolderSpec
			value: self;
			yourself)! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'DaleHenrichs 12/21/2010 13:51'!
setPreLoadDoItInMetacelloSpec: aMetacelloSpec

	aMetacelloSpec setPreLoadDoIt: 
		(aMetacelloSpec project valueHolderSpec
			value: self;
			yourself)! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'dkh 12/11/2009 13:29'!
setProject: aString withInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setProject: aString withString: self! !

!UndefinedObject methodsFor: '*metacello-core' stamp: 'dkh 9/13/2009 07:47'!
setTimestampInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setTimestamp: self! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 11:45'!
addToMetacelloPackages: aMetacelloPackagesSpec

	self do: [:each | each addToMetacelloPackages: aMetacelloPackagesSpec ]
! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 9/6/2012 10:03:17'!
asMetacelloAttributeList
    ^ self! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 9/6/2012 10:03:17'!
asMetacelloAttributePath
    ^ MetacelloMethodSectionPath withAll: self! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 11:46'!
mergeIntoMetacelloPackages: aMetacelloPackagesSpec

	self do: [:each | each mergeIntoMetacelloPackages: aMetacelloPackagesSpec ]
! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 11:42'!
removeFromMetacelloPackages: aMetacelloPackagesSpec

	self do: [:each | each removeFromMetacelloPackages: aMetacelloPackagesSpec ]
! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 9/6/2012 07:42'!
setForDo: aBlock withInMetacelloConfig: aMetacelloConstructore
    aMetacelloConstructore setFor: self do: aBlock! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 9/6/2012 07:43'!
setForVersion: aString withInMetacelloConfig: aMetacelloConstructore
    aMetacelloConstructore setFor: self version: aString! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 9/23/2009 08:46'!
setIncludesInMetacelloPackage: aMetacelloPackageSpec

	aMetacelloPackageSpec setIncludes: self asArray.! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 6/8/2009 19:02'!
setLoadsInMetacelloProject: aMetacelloPackageSpec

	aMetacelloPackageSpec setLoads: self asArray.! !

!Collection methodsFor: '*metacello-core' stamp: 'dkh 6/6/2009 10:08'!
setRequiresInMetacelloPackage: aMetacelloPackageSpec

	aMetacelloPackageSpec setRequires: self asArray.! !

Magnitude subclass: #MetacelloVersion
	instanceVariableNames: 'spec versionNumber importedVersions versionStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Model'!

!MetacelloVersion class methodsFor: 'instance creation' stamp: 'tg 8/30/2009 18:07'!
fromSpec: aMetacelloVersionSpec

	^(self fromString: aMetacelloVersionSpec versionString) 
		spec: aMetacelloVersionSpec;
		yourself! !

!MetacelloVersion class methodsFor: 'instance creation' stamp: 'dkh 8/31/2009 05:13'!
fromString: aString

	^self new versionNumber: aString asMetacelloVersionNumber! !

!MetacelloVersion methodsFor: 'comparing' stamp: 'dkh 6/14/2009 09:40'!
< aMetacelloVersion

	aMetacelloVersion species = self species ifFalse: [ ^false ].
	^self versionNumber < aMetacelloVersion versionNumber! !

!MetacelloVersion methodsFor: 'comparing' stamp: 'dkh 6/14/2009 09:41'!
= aMetacelloVersion

	aMetacelloVersion species = self species ifFalse: [ ^false ].
	^self versionNumber = aMetacelloVersion versionNumber! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 10/13/2009 13:00'!
author

	^self spec author value! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 8/9/2009 11:48'!
blessing

	^self spec blessing value! !

!MetacelloVersion methodsFor: 'private' stamp: 'dkh 7/8/2011 22:26'!
computeVersionStatus
	"
		#allLoadedToSpec - all projects and packages are loaded and match specification
		#loadedToSpec - all loaded projects and packages match specifications (at least one package loaded)
		#loadedMatchConstraints - all loaded projects and packages match constraints (at least one package loaded)
		#somethingLoaded - at least one package loaded
	"

	self spec computeVersionStatus: [ :status | ^ status ].
	^ #noStatus! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 7/31/2009 11:48'!
description

	^self spec description value! !

!MetacelloVersion methodsFor: 'comparing' stamp: 'dkh 6/14/2009 09:41'!
hash

	^self versionNumber hash! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'dkh 1/7/2010 18:48'!
importedVersions

	importedVersions == nil ifTrue: [ importedVersions := #() ].
	^importedVersions! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'dkh 1/7/2010 18:57'!
importedVersions: aCollection

	importedVersions := aCollection! !

!MetacelloVersion methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 10:56'!
isAllLoadedToSpec
	"all projects and packages are loaded and match specification"
	
	^self spec isAllLoadedToSpec! !

!MetacelloVersion methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 11:08'!
isLoadedMatchConstraints
	"all loaded projects and packages match constraints"
	
	^self spec isLoadedMatchConstraints! !

!MetacelloVersion methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 11:07'!
isLoadedToSpec
	"all loaded projects and packages match specifications"
	
	^self spec isLoadedToSpec! !

!MetacelloVersion methodsFor: 'testing' stamp: 'DaleHenrichs 2/4/2010 10:19'!
isPossibleBaseline

	^self spec isPossibleBaseline! !

!MetacelloVersion methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 11:15'!
isSomethingLoaded
	"at least one project or package has been loaded"
	
	^self spec isSomethingLoaded! !

!MetacelloVersion methodsFor: 'actions' stamp: 'dkh 6/8/2009 17:45'!
load

	^self subclassResponsibility! !

!MetacelloVersion methodsFor: 'actions' stamp: 'dkh 6/8/2009 17:45'!
load: required

	^self subclassResponsibility! !

!MetacelloVersion methodsFor: 'querying' stamp: 'DaleHenrichs 10/27/2010 11:30'!
loader

	^self spec loader! !

!MetacelloVersion methodsFor: 'testing' stamp: 'DaleHenrichs 2/8/2010 11:42'!
name

	^self versionString! !

!MetacelloVersion methodsFor: 'printing' stamp: 'DaleHenrichs 11/16/2010 11:14'!
printOn: aStream
	| label vs |
	self blessing ~~ #broken
		ifTrue: [ 
			(vs := self versionStatus) == #somethingLoaded
				ifTrue: [ aStream nextPutAll: '<>' ].
			vs == #loadedMatchConstraints
				ifTrue: [ aStream nextPutAll: '>=' ].
			vs == #loadedToSpec
				ifTrue: [ aStream nextPut: $~ ] ].
	self versionNumber printOn: aStream.
	self spec ~~ nil
		ifTrue: [ 
			(label := self spec projectLabel) isEmpty
				ifFalse: [ aStream nextPutAll: ' [' , label , ']' ] ]! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 6/8/2009 16:03'!
project

	^self spec project! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:32'!
projectLabel

	^self spec projectLabel! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'dkh 05/04/2009 20:26'!
spec

	^spec! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'dkh 05/04/2009 20:26'!
spec: aMetacellVersionSpec

	spec := aMetacellVersionSpec! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 10/13/2009 13:01'!
timestamp

	^self spec timestamp value! !

!MetacelloVersion methodsFor: 'actions' stamp: 'dkh 05/04/2009 20:26'!
unload

	^self spec unload! !

!MetacelloVersion methodsFor: 'querying' stamp: 'DaleHenrichs 9/22/2010 13:52'!
versionKey
	"version printString, without the versionStatus decorations, suitable for using as a unique key for the 
	 receiver in a dictionary"

	^ String streamContents: [:aStream| |label|
		self versionNumber printOn: aStream.
		self spec ~~ nil
			ifTrue: [(label := self spec projectLabel) isEmpty
					ifFalse: [aStream nextPutAll: ' [' , label , ']']] ]! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 6/14/2009 09:39'!
versionNumber

	^versionNumber! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'dkh 6/14/2009 09:39'!
versionNumber: aVersionNumber

	versionNumber := aVersionNumber! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'dkh 6/15/2009 20:07'!
versionSpec

	^self spec! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 2/6/2010 16:49'!
versionStatus

	versionStatus == nil ifTrue: [ versionStatus := self computeVersionStatus].
	^versionStatus! !

!MetacelloVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 2/4/2010 10:10'!
versionStatus: aSymbol

	versionStatus := aSymbol! !

!MetacelloVersion methodsFor: 'querying' stamp: 'dkh 8/31/2009 05:11'!
versionString

	^self versionNumber versionString ! !

!MetacelloVersion methodsFor: 'comparing' stamp: 'dkh 6/14/2009 12:42'!
~> aMetacelloVersion

	aMetacelloVersion species = self species ifFalse: [ ^false ].
	^self versionNumber ~> aMetacelloVersion versionNumber! !

Magnitude variableSubclass: #MetacelloVersionNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Model'!

!MetacelloVersionNumber commentStamp: 'dkh 6/22/2012 12:00' prior: 0!
# Metacello version format

Thanks to [Mozilla Toolkit version format](https://developer.mozilla.org/en/Toolkit_version_format) for inspiration.

##Version Format
A version string consists of one or more version parts, separated with dots or dashes.

A version part with a leading dot is numeric. A version part with a leading dash is string.

The rationale behind splitting a version part into a sequence of strings and numbers is that when comparing version parts, the numeric parts are compared as numbers, e.g. '1.0-pre.1' < '1.0-pre.10', while the strings are compared bytewise. See the next section for details on how versions are compared.

##Comparing versions

When two version strings are compared, their version parts are compared left to right. Empty parts are ignored.

If at some point a version part of one version string is greater than the corresponding version part of another version string, then the first version string is greater than the other one.

If a version string has extra parts and the common parts are equal, the shorter version string is less than the longer version string (1.0 is less than 1.0.0).

Otherwise, the version strings are equal. 

##Comparing version parts

Version parts are also compared left to right, A string-part that exists is always less-then a nonexisting string-part (1.6-a is less than 1.6).

Examples

```
1 == 1. < 1.0 == 1..--0
< 1.1-a < 1.1-aa < 1.1-ab < 1.1-b < 1.1-c
< 1.1-pre < 1.1-pre.0 
< 1.1-pre.1-a < 1.1-pre.1-aa < 1.1-pre.1-b < 1.1-pre.1
< 1.1-pre.2
< 1.1-pre.10
< 1.1 < 1.1.0 < 1.1.00
< 1.10
< 2.0
```!

!MetacelloVersionNumber class methodsFor: 'private' stamp: 'TestRunner 10/19/2009 10:22'!
extractNumericComponent: subString
	"$. separated components are integers"

	| number |
	number := [subString asNumber] 
						on: Error 
						do: [:ex | ex return: subString ].
	^number asString = subString
		ifTrue: [ number ]
		ifFalse: [ subString ]! !

!MetacelloVersionNumber class methodsFor: 'instance creation' stamp: 'dkh 8/13/2009 12:20'!
fromString: aString

	| new components |
	components := OrderedCollection new.
	(aString findTokens: '.') do: [:subString | | strs |
		strs := subString findTokens: '-'.
		"first subString token could be an integer"
		components add: (self extractNumericComponent: strs first).
		strs size > 1
			ifTrue: [
				"remaining are uncoditionally Strings, because of leading $-"
				components addAll: strs allButFirst ]].
	new := self new: components size.
	1 to: components size do: [:i | new at: i put: (components at: i) ].
	^new! !

!MetacelloVersionNumber methodsFor: 'comparing' stamp: 'DaleHenrichs 10/6/2010 11:14'!
< aMetacelloVersionNumber

	| condensed aCondensed |
	aMetacelloVersionNumber species = self species
		ifFalse: [ ^ false ].
	condensed := self collapseZeros.
	aCondensed := aMetacelloVersionNumber collapseZeros.
	(condensed ~~ self or: [ aCondensed ~~ aMetacelloVersionNumber ])
		ifTrue: [ ^ condensed compareLessThan: aCondensed ].
	^ self compareLessThan: aMetacelloVersionNumber! !

!MetacelloVersionNumber methodsFor: 'comparing' stamp: 'DaleHenrichs 10/6/2010 11:14'!
= aMetacelloVersionNumber

	| condensed aCondensed |
	aMetacelloVersionNumber species = self species
		ifFalse: [ ^ false ].
	condensed := self collapseZeros.
	aCondensed := aMetacelloVersionNumber collapseZeros.
	(condensed ~~ self or: [ aCondensed ~~ aMetacelloVersionNumber ])
		ifTrue: [ ^ condensed compareEqualTo: aCondensed ].
	^ self compareEqualTo: aMetacelloVersionNumber! !

!MetacelloVersionNumber methodsFor: 'accessing' stamp: 'dkh 6/14/2009 13:29'!
approximateBase

	| base |
	base := self copyFrom: 1 to: self size - 1.
	base at: base size put: (base at: base size) + 1.
	^base! !

!MetacelloVersionNumber methodsFor: 'converting' stamp: 'dkh 6/14/2009 09:29'!
asMetacelloVersionNumber

	^self! !

!MetacelloVersionNumber methodsFor: 'private' stamp: 'DaleHenrichs 10/16/2010 10:15'!
collapseZeros
	"the rule must be that zeros can be collapsed as long as the series of zeros ends in a string term"

	| collection newSize new j lastElementIsStringOrZero canCollapse |
	(self size = 0 or: [ self at: 1 ]) == 0
		ifTrue: [ ^ self ].
	collection := OrderedCollection new.
	lastElementIsStringOrZero := true.
	canCollapse := true.
	self size to: 1 by: -1 do: [ :i | 
		| element |
		element := self at: i.
		(canCollapse and: [ element == 0 ])
			ifTrue: [ 
				lastElementIsStringOrZero
					ifFalse: [ 
						canCollapse := false.
						collection addFirst: element.]]
			ifFalse: [ 
				collection addFirst: element.
				canCollapse := lastElementIsStringOrZero := element isString ] ].
	collection size = self size
		ifTrue: [ ^ self ].
	newSize := collection size.
	new := self species new: newSize.
	j := 0.
	collection
		do: [ :element | 
			new at: j + 1 put: element.
			j := j + 1 ].
	^ new! !

!MetacelloVersionNumber methodsFor: 'private' stamp: 'DaleHenrichs 10/5/2010 17:31'!
compareEqualTo: aMetacelloVersionNumber

	| mySize |
	aMetacelloVersionNumber species = self species ifFalse: [ ^false ].
	mySize := self size.
	mySize = aMetacelloVersionNumber size 
		ifFalse: [ ^false ].
	1 to: mySize do: [:i |
		(self at: i) = (aMetacelloVersionNumber at: i) ifFalse: [ ^false ]].
	^true! !

!MetacelloVersionNumber methodsFor: 'private' stamp: 'DaleHenrichs 10/5/2010 17:29'!
compareLessThan: aMetacelloVersionNumber

	| mySize aSize commonSize count more |
	mySize := self size.
	aSize := aMetacelloVersionNumber size.
	commonSize :=  mySize min: aSize.
	count := 0.
	more := true.
	[ more and: [ count < commonSize ]] whileTrue: [
		(self at: count + 1) = (aMetacelloVersionNumber at: count + 1)
			ifTrue: [ count := count + 1 ]
			ifFalse: [ more := false ]].
	count < commonSize
		ifTrue: [ 
			^(self at: count + 1) 
				metacelloVersionComponentLessThan: (aMetacelloVersionNumber at: count + 1) ].
	mySize < aSize
		ifTrue: [ 
			mySize = 0 ifTrue: [ ^true ].
			"if the versions at commonSize are equal and the next version slot in aMetacelloVersionNumber 
			 is a string, then it's considered that I'm > aMetacelloVersionNumber
			 (i.e., '2.9.9' is greater than '2.9.9-alpha.2')"
			(self at: commonSize) = (aMetacelloVersionNumber at: commonSize)
				ifFalse: [ ^true ]. 
			^(aMetacelloVersionNumber at: commonSize+1) isString not]
		ifFalse: [ 
			mySize = aSize ifTrue: [ ^false ].
			aSize <= 0 ifTrue: [ ^false ].
			"if the versions at commonSize are equal and the next version slot is a string, 
			 then it's considered that I'm < aMetacelloVersionNumber
			 (i.e., '2.9.9-alpha.2' is less than '2.9.9')"
			(self at: commonSize) = (aMetacelloVersionNumber at: commonSize)
				ifFalse: [ ^false ].
			 ^(self at: commonSize+1) isString]
! !

!MetacelloVersionNumber methodsFor: 'copying' stamp: 'dkh 6/14/2009 12:53'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize new j |
	newSize := stop - start + 1.
	new := self species new: newSize.
	j := 0.
	start to: stop do: [:i |
		new at: j + 1 put: (self at: i).
		j := j + 1 ].
	^new! !

!MetacelloVersionNumber methodsFor: 'operations' stamp: 'DaleHenrichs 11/15/2010 13:33'!
decrementMinorVersionNumber
	| int |
	self size to: 1 by: -1 do: [ :index | 
		(int := self at: index) isString
			ifFalse: [ 
				int > 0
					ifTrue: [ self at: index put: int - 1 ].
				^ self ] ]! !

!MetacelloVersionNumber methodsFor: 'enumerating' stamp: 'dkh 6/14/2009 09:37'!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!MetacelloVersionNumber methodsFor: 'enumerating' stamp: 'dkh 6/14/2009 09:37'!
do: elementBlock separatedBy: separatorBlock
	"Evaluate the elementBlock for all elements in the receiver,
	and evaluate the separatorBlock between."

	| beforeFirst | 
	beforeFirst := true.
	self do:
		[:each |
		beforeFirst
			ifTrue: [beforeFirst := false]
			ifFalse: [separatorBlock value].
		elementBlock value: each]! !

!MetacelloVersionNumber methodsFor: 'comparing' stamp: 'dkh 06/15/2009 14:30'!
hash

"Returns a numeric hash key for the receiver."

| mySize interval hashValue |

(mySize := self size) == 0
  ifTrue: [ ^15243 ].

"Choose an interval so that we sample at most 5 elements of the receiver"
interval := ((mySize - 1) // 4) max: 1.

hashValue := 4459.
1 to: mySize by: interval do: [ :i | | anElement |
  anElement := self at: i.
  (anElement isKindOf: SequenceableCollection)
    ifTrue: [
      hashValue := (hashValue bitShift: -1) bitXor: anElement size.
      ]
    ifFalse: [
      hashValue := (hashValue bitShift: -1) bitXor: anElement hash.
      ].
  ].

^ hashValue abs
! !

!MetacelloVersionNumber methodsFor: 'operations' stamp: 'dkh 10/7/2009 14:28'!
incrementMinorVersionNumber

	| int |
	self size to: 1 by: -1 do: [:index | 
		(int := self at: index) isString 
			ifFalse: [ 
				self at: index put: int + 1.
				^self ]].! !

!MetacelloVersionNumber methodsFor: 'comparing' stamp: 'dkh 12/21/2009 13:32'!
match: aVersionPattern
	"Answer whether the version number of the receiver matches the given pattern string.

	 A Metacello version number is made up of version sequences delimited by the characters $. and $-.
	 The $. introduces a numeric version sequence and $- introduces an alphanumeric version sequence.
	 
	 A version pattern is made up of version pattern match sequences. also delimited by the characters $. 
	 and $-.. Each pattern match sequence is tested against the corresponding version sequence of the 
	 receiver, using the 'standard' pattern matching rules. All sequences must answer true for a match.
	
	 The special pattern sequence '?' is a match for the corresponding version sequence and all subsequent 
	 version sequences. '?' as the version pattern matches all versions. No more version pattern 
	 sequences are permitted once the '?' sequence is used. If used, it is the last version pattern
	 sequence. "
	
	| patternVersion mySize patternSize |
	patternVersion := aVersionPattern asMetacelloVersionNumber.
	mySize := self size.
	patternSize := patternVersion size.
	mySize = patternSize 
		ifFalse: [ 
			mySize < patternSize ifTrue: [ ^false ].
			(patternVersion at: patternSize) ~= '?' ifTrue: [ ^false ].
			mySize := patternSize ].
	1 to: mySize do: [:i | | pattern |
		pattern := (patternVersion at: i) asString.
		pattern = '?'
			ifTrue: [i = mySize ifFalse: [ ^self error: 'Invalid version match pattern: ', aVersionPattern printString ]]
			ifFalse: [ (pattern match: (self at: i) asString)  ifFalse: [ ^false ]]].
	^true
"
  '1.1.1' asMetacelloVersionNumber match: '*.*.*'. -> true
  '1.1.1' asMetacelloVersionNumber match: '*.#.*'. -> true
  '1.10.1' asMetacelloVersionNumber match: '*.#.*'. -> false
  '1.1.1' asMetacelloVersionNumber match: '*.*'. -> false
  '1.1.1' asMetacelloVersionNumber match: '*.?'. -> true
  '1.0' asMetacelloVersionNumber match: '1.?'. -> true
  '2.0' asMetacelloVersionNumber match: '1.?'. -> false
  '1.1.1' asMetacelloVersionNumber match: '?'. -> true
  '1' asMetacelloVersionNumber match: '*.?'. -> false
  '1-alpha5.0' asMetacelloVersionNumber match: '1-alpha*.?'. -> true
  '1-alpha15.0.1' asMetacelloVersionNumber match: '1-alpha*.?'. -> true
  '1.1' asMetacelloVersionNumber match: '?.?'. -> ERROR: invalid version match pattern
"
! !

!MetacelloVersionNumber methodsFor: 'printing' stamp: 'dkh 6/14/2009 09:59'!
printOn: aStream

	| beforeFirst | 
	beforeFirst := true.
	self do:
		[:each |
		beforeFirst
			ifTrue: [beforeFirst := false]
			ifFalse: [
				each isString
					ifTrue: [ aStream nextPut: $- ]
					ifFalse: [ aStream nextPut: $. ] ].
		aStream nextPutAll: each asString ]
! !

!MetacelloVersionNumber methodsFor: 'accessing' stamp: 'dkh 6/14/2009 09:57'!
versionString

	| strm |
	strm := WriteStream on: String new.
	self printOn: strm.
	^strm contents! !

!MetacelloVersionNumber methodsFor: 'comparing' stamp: 'dkh 6/14/2009 13:30'!
~> aMetacelloVersionNumber

	aMetacelloVersionNumber size == 1 ifTrue: [ ^false ].
	^self >= aMetacelloVersionNumber and: [ self < aMetacelloVersionNumber approximateBase ]! !

!BlockClosure methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:12'!
setAuthorInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setAuthorWithBlock: self! !

!BlockClosure methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:12'!
setBlessingInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setBlessingWithBlock: self! !

!BlockClosure methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:14'!
setDescriptionInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setDescriptionWithBlock: self! !

!BlockClosure methodsFor: '*metacello-core' stamp: 'dkh 10/9/2009 11:28'!
setPackage: aString withInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setPackage: aString withBlock: self! !

!BlockClosure methodsFor: '*metacello-core' stamp: 'dkh 10/9/2009 11:17'!
setProject: aString withInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setProject: aString withBlock: self! !

!BlockClosure methodsFor: '*metacello-core' stamp: 'dkh 10/7/2009 00:15'!
setTimestampInMetacelloConfig: aMetacelloConfig

	aMetacelloConfig setTimestampWithBlock: self! !

!Integer methodsFor: '*metacello-core' stamp: 'dkh 8/13/2009 10:38'!
metacelloIntegerLessThanSelf: anInteger

	^anInteger < self! !

!Integer methodsFor: '*metacello-core' stamp: 'dkh 8/13/2009 12:04'!
metacelloStringLessThanSelf: aString
	"string version components are always '<' integer component"
	
	^true! !

!Integer methodsFor: '*metacello-core' stamp: 'dkh 8/13/2009 10:36'!
metacelloVersionComponentLessThan: aMetacelloVersonComponent

	^aMetacelloVersonComponent metacelloIntegerLessThanSelf: self! !

Array variableSubclass: #MetacelloMethodSectionPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloMethodSectionPath methodsFor: 'conversion' stamp: 'dkh 9/7/2012 14:00'!
asAttributeOrPath
    self size = 1
        ifTrue: [ 
            | attribute |
            attribute := self at: 1.
            ^ attribute size = 1
                ifTrue: [ attribute at: 1 ]
                ifFalse: [ attribute ] ].
    ^ self! !

!MetacelloMethodSectionPath methodsFor: 'conversion' stamp: 'dkh 9/7/2012 13:41'!
asMetacelloAttributePath
    ^ self! !

Object subclass: #MetacelloAbstractConstructor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloAbstractConstructor methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 11:41'!
configurationClass

	^self subclassResponsibility! !

!MetacelloAbstractConstructor methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/3/2010 11:44'!
extractAllVersionPragmas

	| aDict |
	aDict := Dictionary new.
	self extractPragmas: #version: into: aDict.
	self extractPragmas: #version:imports: into: aDict.
	^aDict! !

!MetacelloAbstractConstructor methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/8/2010 10:16'!
extractCommonDefaultSymbolicVersionPragmas

	| aDict |
	aDict := Dictionary new.
	self extractPragmas: #defaultSymbolicVersion: for: MetacelloBaseConfiguration into: aDict.
	^aDict! !

!MetacelloAbstractConstructor methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/8/2010 09:58'!
extractDefaultSymbolicVersionPragmas

	| aDict |
	aDict := Dictionary new.
	self extractPragmas: #defaultSymbolicVersion: into: aDict.
	^aDict! !

!MetacelloAbstractConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/8/2010 10:02'!
extractPragmas: pragmaKeyword for: aClass into: versionDict

	| versionString  pragmas |
	(Pragma 
		allNamed: pragmaKeyword
		in: aClass) do: [:pragma |
			versionString := pragma argumentAt: 1.
			pragmas := versionDict 
				at: versionString 
				ifAbsent: [ | list |
					list := OrderedCollection new.
					versionDict at: versionString put: list.
					list ].
			pragmas add: pragma ].
! !

!MetacelloAbstractConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/8/2010 10:02'!
extractPragmas: pragmaKeyword into: versionDict

	^self extractPragmas: pragmaKeyword for: self configurationClass into: versionDict
! !

!MetacelloAbstractConstructor methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/3/2010 11:43'!
extractSymbolicVersionPragmas

	| aDict |
	aDict := Dictionary new.
	self extractPragmas: #symbolicVersion: into: aDict.
	^aDict! !

!MetacelloAbstractConstructor methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/3/2010 11:43'!
extractVersionImportPragmas

	| aDict |
	aDict := Dictionary new.
	self extractPragmas: #version:imports: into: aDict.
	^aDict! !

!MetacelloAbstractConstructor methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/3/2010 11:43'!
extractVersionPragmas

	| aDict |
	aDict := Dictionary new.
	self extractPragmas: #version: into: aDict.
	^aDict! !

MetacelloAbstractConstructor subclass: #MetacelloAbstractVersionConstructor
	instanceVariableNames: 'root configuration project attributeMap attributeOrder symbolicVersion currentContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloAbstractVersionConstructor class methodsFor: 'method generation' stamp: 'DaleHenrichs 11/13/2010 18:13'!
symbolicMethodSelectorAndPragma: selector symbolicVersionSymbol: symbolicVersionSymbol on: strm
	strm
		nextPutAll: selector asString , ' spec';
		cr;
		tab;
		nextPutAll: '<symbolicVersion: #' , symbolicVersionSymbol asString printString;
		nextPutAll: '>';
		cr! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'DaleHenrichs 12/4/2010 09:56'!
addAttribute: anAttribute

	self attributeOrder add: anAttribute! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:28'!
attributeMap

	attributeMap == nil ifTrue: [ attributeMap := Dictionary new ].
	^attributeMap! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'dkh 10/5/2009 16:41'!
attributeOrder

	attributeOrder == nil ifTrue: [ attributeOrder := OrderedCollection new ].
	^attributeOrder! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
author: aBlockOrString

	aBlockOrString setAuthorInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
blessing: aBlockOrString

	aBlockOrString setBlessingInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
className: anObject

	self root className: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:26'!
configuration

	^configuration! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:26'!
configuration: aConfig

	configuration := aConfig! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 11:41'!
configurationClass

	^self configuration class! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
description: aBlockOrString

	aBlockOrString setDescriptionInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 12:28'!
evaluatePragma: pragma
	currentContext := pragma.
	[ self configuration perform: pragma selector with: self ] ensure: [ currentContext := nil ]! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
file: anObject

	self root file: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'dkh 9/6/2012 07:41'!
for: attributeListOrSymbol do: aBlock
    "conditional version support"

    attributeListOrSymbol setForDo: aBlock withInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'dkh 9/6/2012 07:41'!
for: attributeListOrSymbol version: aString
    "conditional symbolicVersion support"

    attributeListOrSymbol setForVersion: aString withInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
group: aString overrides: aStringOrCollection

	| spec |
	spec := 
		(self project groupSpec)
			name: aString;
			includes: aStringOrCollection;
			yourself.
	self root packages add: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
group: aString with: aStringOrCollection

	| spec |
	spec := 
		(self project groupSpec)
			name: aString;
			includes: aStringOrCollection;
			yourself.
	self root packages merge: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
includes: anObject

	self root includes: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
loads: anObject

	self root loads: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
name: anObject

	self root name: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
operator: anObject

	self root operator: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
package: aString

	| spec |
	spec := 
		(self project packageSpec)
			name: aString;
			yourself.
	self root packages add: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
package: aString overrides: aBlock

	| spec |
	spec := 
		(self project packageSpec)
			name: aString;
			yourself.
	self root packages add: spec.
	self with: spec during: aBlock
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
package: aString with: aBlockOrString

	aBlockOrString setPackage: aString withInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
postLoadDoIt: aSymbol

	self validateDoItSelector: aSymbol.
	self root postLoadDoIt: aSymbol! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
preLoadDoIt: aSymbol

	self validateDoItSelector: aSymbol.
	self root preLoadDoIt: aSymbol! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 03/12/2011 22:11'!
project: aString

	self project: aString with: ''
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
project: aString copyFrom: oldSpecName with: aBlock

	| spec projectSpec |
	projectSpec := 
		(self project projectSpec)
			name: aString;
			projectPackage: self project packageSpec;
			yourself.
	spec := 
		(self project projectReferenceSpec)
			name: aString;
			projectReference: projectSpec;
			yourself.
	self root packages copy: oldSpecName to: spec.
	self with: projectSpec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
project: aString overrides: aBlock

	| spec projectSpec |
	projectSpec := 
		(self project projectSpec)
			name: aString;
			projectPackage: self project packageSpec;
			yourself.
	projectSpec projectPackage: self project packageSpec.
	spec := 
		(self project projectReferenceSpec)
			name: aString;
			projectReference: projectSpec;
			yourself.
	self root packages add: spec.
	self with: projectSpec during: aBlock
	! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
project: aString with: aBlockOrString

	aBlockOrString setProject: aString withInMetacelloConfig: self
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
projectPackage: aBlock

	| spec |
	(spec := self root projectPackage) == nil
		ifTrue: [ 
			spec := self project packageSpec.
			self root projectPackage: spec ].
	self with: spec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
removeGroup: aString

	| spec |
	spec := 
		(self project groupSpec)
			name: aString;
			yourself.
	self root packages remove: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
removePackage: aString

	| spec |
	spec := 
		(self project packageSpec)
			name: aString;
			yourself.
	self root packages remove: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
removeProject: aString

	| spec |
	spec := 
		(self project projectReferenceSpec)
			name: aString;
			yourself.
	self root packages remove: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
repositories: aBlock

	self with: self root repositories during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
repository: anObject

	self root repository: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
repository: description username: username password: password

	self root repository: description username: username password: password! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
requires: anObject

	self root requires: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'initialization' stamp: 'dkh 10/5/2009 16:42'!
reset

	attributeMap := attributeOrder := nil
! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:36'!
root

	^root! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:37'!
root: aMetacelloSpec

	root := aMetacelloSpec! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setAuthorWithBlock: aBlock

	| spec |
	(spec := self root getAuthor) == nil
		ifTrue: [ 
			spec := self project valueHolderSpec.
			self root setAuthor: spec ].
	self with: spec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setAuthorWithString: aString

	self root author: aString! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setBlessingWithBlock: aBlock

	| spec |
	(spec := self root getBlessing) == nil
		ifTrue: [ 
			spec := self project valueHolderSpec.
			self root setBlessing: spec ].
	self with: spec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setBlessingWithString: aString

	self root blessing: aString! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setDescriptionWithBlock: aBlock

	| spec |
	(spec := self root getDescription) == nil
		ifTrue: [ 
			spec := self project valueHolderSpec.
			self root setDescription: spec ].
	self with: spec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setDescriptionWithString: aString

	self root description: aString! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'EstebanLorenzano 4/24/2013 18:46'!
setFor: attributeList do: aBlock
    "conditional version support"

    attributeList asMetacelloAttributeList
        do: [ :attribute | 
            | blockList |
            blockList := self attributeMap
                at: attribute
                ifAbsentPut: [ OrderedCollection new ].
            blockList add: aBlock.
            self addAttribute: attribute ]! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'dkh 9/5/2012 06:26:03.064'!
setFor: attributeList version: aString
    "conditional symbolicVersion support"

    attributeList asMetacelloAttributeList
        do: [ :attribute | 
            self attributeMap at: attribute put: aString.
            self addAttribute: attribute ]! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setPackage: aString withBlock: aBlock

	| spec |
	spec := 
		(self project packageSpec)
			name: aString;
			yourself.
	self root packages merge: spec.
	self with: spec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setPackage: aString withString: aFile

	| spec |
	spec := 
		(self project packageSpec)
			name: aString;
			file: aFile;
			yourself.
	self root packages merge: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'DaleHenrichs 03/12/2011 22:10'!
setProject: aProject

	project := aProject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setProject: aString withBlock: aBlock

	| spec projectSpec |
	projectSpec := 
		(self project projectSpec)
			name: aString;
			projectPackage: self project packageSpec;
			yourself.
	projectSpec projectPackage: self project packageSpec.
	spec := 
		(self project projectReferenceSpec)
			name: aString;
			projectReference: projectSpec;
			yourself.
	self root packages merge: spec.
	self with: projectSpec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setProject: aString withString: versionString

	| spec projectSpec |
	projectSpec := 
		(self project projectSpec)
			name: aString;
			versionString: versionString;
			yourself.
	spec := 
		(self project projectReferenceSpec)
			name: aString;
			projectReference: projectSpec;
			yourself.
	self root packages merge: spec.
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setTimestampWithBlock: aBlock

	| spec |
	(spec := self root getTimestamp) == nil
		ifTrue: [ 
			spec := self project valueHolderSpec.
			self root setTimestamp: spec ].
	self with: spec during: aBlock! !

!MetacelloAbstractVersionConstructor methodsFor: 'api callbacks' stamp: 'DaleHenrichs 11/12/2010 09:54'!
setTimestampWithString: aString

	self root timestamp: aString! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
supplyingAnswers: aCollection

	self root answers: aCollection! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'DaleHenrichs 9/22/2010 16:43'!
symbolicVersion

	^symbolicVersion! !

!MetacelloAbstractVersionConstructor methodsFor: 'accessing' stamp: 'DaleHenrichs 9/22/2010 16:43'!
symbolicVersion: aSymbol

	symbolicVersion := aSymbol! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
timestamp: aBlockOrString

	aBlockOrString setTimestampInMetacelloConfig: self! !

!MetacelloAbstractVersionConstructor methodsFor: 'validation' stamp: 'DaleHenrichs 11/12/2010 10:28'!
validateDoItSelector: anObject

	anObject == nil ifTrue: [ ^ self ].
	anObject isSymbol ifFalse: [ self error: 'Invalid message selector for doit: ', anObject printString ].
! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
value: anObject

	self root value: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
version: anObject

	self root versionString: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'api' stamp: 'DaleHenrichs 11/12/2010 09:54'!
versionString: anObject

	self root versionString: anObject! !

!MetacelloAbstractVersionConstructor methodsFor: 'private' stamp: 'dkh 10/3/2009 16:31'!
with: aMetacelloSpec during: aBlock 

	| previousRoot |
	previousRoot := self root.
	self root: aMetacelloSpec.
	aBlock
		ensure: [self root: previousRoot]! !

MetacelloAbstractVersionConstructor subclass: #MetacelloToolBoxConstructor
	instanceVariableNames: 'currentSection methodSections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloToolBoxConstructor methodsFor: 'private' stamp: 'DaleHenrichs 12/22/2010 09:56'!
evaluateMethodSection: methodSection version: sourceVersionString
	| versionSpec |
	versionSpec := self project versionSpec.
	versionSpec versionString: sourceVersionString.
	methodSection versionSpec: versionSpec.
	currentSection := methodSection.
	self with: versionSpec during: methodSection block.
	methodSection methodSections do: [ :ms | self evaluateMethodSection: ms version: sourceVersionString ]! !

!MetacelloToolBoxConstructor methodsFor: 'extraction' stamp: 'DaleHenrichs 12/22/2010 11:07'!
extractMethodSectionsFor: sourceVersionString
	| coll pragma |
	coll := self extractAllVersionPragmas at: sourceVersionString ifAbsent: [ ^ #() ].
	coll size > 1
		ifTrue: [ self error: 'More than one pragma defining ' , sourceVersionString printString ].
	pragma := coll at: 1.
	self evaluatePragma: pragma.
	self methodSections do: [ :methodSection | self evaluateMethodSection: methodSection version: sourceVersionString ].
! !

!MetacelloToolBoxConstructor methodsFor: 'extraction' stamp: 'DaleHenrichs 11/15/2010 10:06'!
extractSymbolicVersionSpecsFor: sourceVersionSymbol
	| coll versionSpec pragma |
	coll := self extractSymbolicVersionPragmas at: sourceVersionSymbol ifAbsent: [ ^ #() ].
	coll size > 1
		ifTrue: [ self error: 'More than one pragma defining ' , sourceVersionSymbol printString ].
	pragma := coll at: 1.
	self evaluatePragma: pragma.
	^ self methodSections

! !

!MetacelloToolBoxConstructor methodsFor: 'private' stamp: 'DaleHenrichs 12/23/2010 15:21'!
methodSection: methodSection do: aBlock

	methodSection methodSections do: aBlock.
	methodSection methodSections do: [ :ms | self methodSection: ms do: aBlock ]! !

!MetacelloToolBoxConstructor methodsFor: 'private' stamp: 'dkh 9/7/2012 10:43'!
methodSection: methodSection inEvaluationOrder: attributes do: aBlock
    | selected |
    selected := IdentitySet new.
    attributes
        do: [ :attribute | 
            methodSection methodSections
                do: [ :ms | 
                    (ms attributes includes: attribute)
                        ifTrue: [ selected add: ms ] ] ].
    selected do: aBlock.
    attributes size == 1
        ifTrue: [ ^ self ].
    selected
        do: [ :ms | self methodSection: ms inEvaluationOrder: (attributes copyFrom: 2 to: attributes size) do: aBlock ]! !

!MetacelloToolBoxConstructor methodsFor: 'accessing' stamp: 'dkh 9/13/2012 16:09'!
methodSectionAttributes
    | attributes |
    attributes := Set new.
    self methodSectionsDo: [ :methodSection | attributes addAll: methodSection attributes ].
    ^ attributes! !

!MetacelloToolBoxConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/14/2010 02:08'!
methodSections

	methodSections == nil ifTrue: [ methodSections := OrderedCollection new ].
	^methodSections! !

!MetacelloToolBoxConstructor methodsFor: 'enumeration' stamp: 'DaleHenrichs 12/23/2010 15:10'!
methodSectionsDo: aBlock

	self methodSection: self do: aBlock
! !

!MetacelloToolBoxConstructor methodsFor: 'enumeration' stamp: 'dkh 9/7/2012 10:40'!
methodSectionsInEvaluationOrder: attributes do: aBlock
    "breadth first traversal ... to collect selected sections, then evaluate individual sections in attribute order"

    | selected processed |
    selected := IdentitySet new.
    self methodSection: self inEvaluationOrder: attributes do: [ :methodSection | selected add: methodSection ].
    processed := IdentitySet new.
    attributes
        do: [ :attribute | 
            | list |
            list := OrderedCollection new.
            selected
                do: [ :methodSection | 
                    (processed includes: methodSection)
                        ifFalse: [ 
                            (methodSection attributes includes: attribute)
                                ifTrue: [ 
                                    list add: methodSection.
                                    processed add: methodSection ] ] ].
            list do: aBlock ]! !

!MetacelloToolBoxConstructor methodsFor: 'initialization' stamp: 'DaleHenrichs 11/18/2010 16:40'!
reset
	super reset.	"not needed, but included for completeness"
	methodSections := nil! !

!MetacelloToolBoxConstructor methodsFor: 'api callbacks' stamp: 'dkh 9/5/2012 06:26:03.064'!
setFor: attributeList do: aBlock
    "conditional version support"

    | methodSection |
    methodSection := MetacelloVersionMethodSection new
        attributes: attributeList asMetacelloAttributeList;
        block: aBlock;
        yourself.
    currentSection ~~ nil
        ifTrue: [ currentSection addMethodSection: methodSection ]
        ifFalse: [ self methodSections add: methodSection ]! !

!MetacelloToolBoxConstructor methodsFor: 'api callbacks' stamp: 'dkh 9/5/2012 06:26:03.064'!
setFor: attributeList version: aString
    "conditional symbolicVersion support"

    self methodSections
        add:
            (MetacelloSymbolicVersionSpec new
                attributes: attributeList asMetacelloAttributeList;
                versionString: aString;
                yourself)! !

MetacelloAbstractVersionConstructor subclass: #MetacelloVersionConstructor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloVersionConstructor class methodsFor: 'instance creation' stamp: 'DaleHenrichs 11/12/2010 09:47'!
on: aConfig

	^(self new)
		on: aConfig;
		yourself! !

!MetacelloVersionConstructor class methodsFor: 'instance creation' stamp: 'DaleHenrichs 11/12/2010 09:47'!
on: aConfig project: aProject

	^(self new)
		on: aConfig project: aProject;
		yourself! !

!MetacelloVersionConstructor class methodsFor: 'deprecated' stamp: 'DaleHenrichs 11/18/2010 16:48'!
spawnPackageMethodIn: aConfig category: methodCategory named: newSelector sourceVersion: sourceVersionString targetVersion: targetVersionString blessing: blessing

	self deprecated: 'see MetacelloToolBox class>>createDevelopment:for:importFromBaseline:description: for a similar example'.
	^self new
		spawnPackageMethodIn: aConfig 
		category: methodCategory 
		named: newSelector
		sourceVersion: sourceVersionString 
		targetVersion: targetVersionString
		blessing: blessing! !

!MetacelloVersionConstructor class methodsFor: 'deprecated' stamp: 'DaleHenrichs 11/18/2010 16:48'!
spawnPackageMethodIn: aConfig named: newSelector sourceVersion: sourceVersionString targetVersion: targetVersionString

	self deprecated: 'see MetacelloToolBox class>>createDevelopment:for:importFromBaseline:description: for a similar example'.
	^self 
		spawnPackageMethodIn: aConfig 
		category: 'versions'
		named: newSelector 
		sourceVersion: sourceVersionString 
		targetVersion: targetVersionString 
		blessing: #development! !

!MetacelloVersionConstructor class methodsFor: 'deprecated' stamp: 'DaleHenrichs 11/18/2010 16:48'!
spawnPackageMethodIn: aConfig named: newSelector sourceVersion: sourceVersionString targetVersion: targetVersionString blessing: blessing

	self deprecated: 'see MetacelloToolBox class>>createDevelopment:for:importFromBaseline:description: for a similar example'.
	^self new
		spawnPackageMethodIn: aConfig 
		category: 'versions'
		named: newSelector 
		sourceVersion: sourceVersionString 
		targetVersion: targetVersionString
		blessing: blessing! !

!MetacelloVersionConstructor class methodsFor: 'deprecated' stamp: 'DaleHenrichs 12/20/2010 10:05'!
updatePackageMethodIn: aConfig sourceVersion: sourceVersionString

	self deprecated: 'see MetacelloToolBox class>>updateDevelopment:for:updateProjects:description: for a similar example'.
	^self new
		updatePackageMethodIn: aConfig 
		sourceVersion: sourceVersionString! !

!MetacelloVersionConstructor methodsFor: 'initialization' stamp: 'dkh 7/8/2011 18:57'!
calculate: aConfig project: aProject
	| versionMap symbolicVersionMap executionBlock |
	self setProject: aProject.
	self configuration: aConfig.
	versionMap := Dictionary new.
	symbolicVersionMap := Dictionary new.
	executionBlock := self specResolverBlock.
	self collectAllVersionsFromVersionPragmasInto: versionMap using: executionBlock.
	self
		collectAllVersionsFromVersionImportPragmasInto: versionMap
		using: executionBlock
		satisfiedPragmas: (self versionImportPragmasVerifiedDefinedIn: versionMap).
	self collectAllSymbolicVersionsFromVersionPragmasInto: symbolicVersionMap using: self symbolicVersionResolverBlock.
	self project map: versionMap.
	self project symbolicVersionMap: symbolicVersionMap.
	self project configuration: aConfig.	"now that we have a nearly complete project, we can collect the defaultSymbolicVersions, which expect the project to be fully constructed"
	self
		collectDefaultSymbolicVersionsFromVersionPragmasFrom: self extractDefaultSymbolicVersionPragmas
		into: symbolicVersionMap
		using: self defaultSymbolicVersionResolverBlock.	"Pick up defaults from MetacelloBaseConfiguration"
	self
		collectDefaultSymbolicVersionsFromVersionPragmasFrom: self extractCommonDefaultSymbolicVersionPragmas
		into: symbolicVersionMap
		using: self commonDefaultSymbolicVersionResolverBlock.	"now resolive symbolicVersions defined as symbolicVersions"
	symbolicVersionMap copy
		keysAndValuesDo: [ :symbolic :original | 
			| versionString visited |
			versionString := original.
			visited := Set new.
			[ 
			visited add: versionString.
			versionString isSymbol and: [ versionString ~~ #notDefined ] ]
				whileTrue: [ 
					versionString := symbolicVersionMap
						at: versionString
						ifAbsent: [ self error: 'Cannot resolve symbolic version ' , original printString ].
					(visited includes: versionString)
						ifTrue: [ self error: 'Loop detected resolving symbolic version ' , original printString ] ].
			symbolicVersionMap at: symbolic put: versionString ]! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:50'!
collectAllSymbolicVersionsFromVersionPragmasInto: symbolicVersionMap using: executionBlock
	| defined versionPragmaDict versionString |
	versionPragmaDict := self extractSymbolicVersionPragmas.
	versionPragmaDict
		keysAndValuesDo: [ :versionSymbol :pragmaColl | 
			defined := false.
			pragmaColl
				do: [ :pragma | 
					defined := true.
					versionString := executionBlock value: versionSymbol value: pragma ].
			defined
				ifTrue: [ 
					versionString == nil
						ifFalse: [ symbolicVersionMap at: versionSymbol put: versionString ]].
			self reset ]! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'dkh 9/5/2012 06:03'!
collectAllVersionsFromVersionImportPragmasInto: versionMap using: executionBlock satisfiedPragmas: pragmaDict
    | defined done completed count |
    done := false.
    completed := IdentitySet new.
    count := 0.
    [ 
    count := count + 1.
    count > 10000
        ifTrue: [ self error: 'Apparent loop in import expansion' ].
    done ]
        whileFalse: [ 
            done := true.
            pragmaDict
                keysAndValuesDo: [ :versionString :pragmaColl | 
                    | versionSpec |
                    versionSpec := nil.
                    defined := false.
                    pragmaColl
                        do: [ :pragma | 
                            (completed includes: pragma)
                                ifFalse: [ 
                                    | imports |
                                    done := false.
                                    imports := pragma argumentAt: 2.
                                    imports
                                        detect: [ :importedVersion | (versionMap includesKey: importedVersion) not ]
                                        ifNone: [ 
                                            imports
                                                do: [ :importedVersion | 
                                                    | version |
                                                    (version := versionMap at: importedVersion ifAbsent: [  ]) ~~ nil
                                                        ifTrue: [ 
                                                            defined := true.
                                                            completed add: pragma.
                                                            versionSpec == nil
                                                                ifTrue: [ versionSpec := version spec copy ]
                                                                ifFalse: [ versionSpec := versionSpec mergeSpec: version spec copy ].
                                                            versionSpec versionString: versionString.
                                                            executionBlock value: versionSpec value: pragma ] ] ] ] ].
                    defined
                        ifTrue: [ 
                            | version importedVersions |
                            importedVersions := OrderedCollection new.
                            version := versionSpec createVersion.
                            pragmaColl do: [ :pragma | importedVersions addAll: (pragma argumentAt: 2) ].
                            version importedVersions: importedVersions.
                            self validateVersionString: versionString againstSpec: versionSpec.
                            versionMap at: versionSpec versionString put: version ].
                    self reset ] ]! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:50'!
collectAllVersionsFromVersionPragmasInto: versionMap using: executionBlock
	| defined versionPragmaDict |
	versionPragmaDict := self extractVersionPragmas.
	versionPragmaDict
		keysAndValuesDo: [ :versionString :pragmaColl | 
			| versionSpec |
			versionSpec := self project versionSpec.
			versionSpec versionString: versionString.
			defined := false.
			pragmaColl
				do: [ :pragma | 
					defined := true.
					executionBlock value: versionSpec value: pragma ].
			defined
				ifTrue: [ 
					self validateVersionString: versionString againstSpec: versionSpec.
					versionMap at: versionSpec versionString put: versionSpec createVersion ].
			self reset ]! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:50'!
collectDefaultSymbolicVersionsFromVersionPragmasFrom: versionPragmaDict into: symbolicVersionMap using: executionBlock
	| defined versionString |
	versionPragmaDict
		keysAndValuesDo: [ :versionSymbol :pragmaColl | 
			defined := false.
			symbolicVersionMap
				at: versionSymbol
				ifAbsent: [ 
					"process the defaultSymbolicVersion only if the symbolicVersion is not defined yet"
					pragmaColl
						do: [ :pragma | 
							defined := true.
							versionString := executionBlock value: versionSymbol value: pragma ].
					defined
						ifTrue: [ 
							versionString == nil
								ifFalse: [ symbolicVersionMap at: versionSymbol put: versionString ] ].
					self reset ] ]! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:50'!
commonDefaultSymbolicVersionResolverBlock
	^ self defaultSymbolicVersionResolverBlock: (MetacelloBaseConfiguration new project: self project)
! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:50'!
defaultSymbolicVersionResolverBlock
	^ self defaultSymbolicVersionResolverBlock: self configuration
! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:50'!
defaultSymbolicVersionResolverBlock: receiver
	^ [ :symbolicVrsn :pragma | 
	| result |
	result := nil.
	(pragma argumentAt: 1) = symbolicVrsn
		ifTrue: [ 
			self symbolicVersion: symbolicVrsn.
			result := [ receiver perform: pragma selector ] on: MetacelloVersionDoesNotExistError do: [ :ex | ex return: nil ] ].
	result ]! !

!MetacelloVersionConstructor methodsFor: 'initialization' stamp: 'dkh 7/8/2011 18:58'!
on: aConfig

	| cacheKey |
	cacheKey := aConfig class.
	project := MetacelloPlatform current
		stackCacheFor: #versionConstructor
		at: cacheKey
		doing: [ :cache | 
			self calculate: aConfig project: nil.
			cache at: cacheKey put:  self project ].
	self setProject: project.! !

!MetacelloVersionConstructor methodsFor: 'initialization' stamp: 'dkh 7/8/2011 19:47'!
on: aConfig project: aProject

	| cacheKey cachedProject |
	cacheKey := aConfig class.
	cachedProject := MetacelloPlatform current
		stackCacheFor: #versionConstructor
		at: cacheKey
		doing: [ :cache | 
			self calculate: aConfig project: aProject.
			cache at: cacheKey put:  self project.
			^self ].
	aProject map: cachedProject map.
	aProject symbolicVersionMap: cachedProject symbolicVersionMap.
	aProject configuration: aConfig.
	self setProject: aProject! !

!MetacelloVersionConstructor methodsFor: 'deprecated' stamp: 'DaleHenrichs 11/18/2010 16:48'!
prepareForMethodUpdate: aConfig sourceVersion: sourceVersionString forceUpdate: forceUpdate generating: generateBlock
	| pragmaDict versionSpecs pragmaMap updatedPackageSpecs updatedPackageSpecsMap reversed pragmaColl seenUpdatedPackageSpecs |
	self deprecated: 'see MetacelloToolBox for replacement methods'.
	self configuration: aConfig.
	versionSpecs := Dictionary new.
	pragmaMap := Dictionary new.
	pragmaDict := self extractAllVersionPragmas.
	pragmaColl := pragmaDict at: sourceVersionString ifAbsent: [ ^ self ].
	pragmaColl
		do: [ :pragma | 
			| specs versionSpec |
			specs := Dictionary new.
			self evaluatePragma: pragma.
			self attributeMap
				keysAndValuesDo: [ :attribute :blockList | 
					versionSpec := self project versionSpec.
					versionSpec versionString: sourceVersionString.
					specs at: attribute put: versionSpec.
					blockList do: [ :block | self with: versionSpec during: block ] ].
			versionSpecs
				at: pragma selector
				put:
					{specs.
					(self attributeOrder).
					nil}.
			pragmaMap at: pragma selector put: pragma.
			self reset ].
	versionSpecs
		keysAndValuesDo: [ :selector :ar | 
			updatedPackageSpecsMap := Dictionary new.
			seenUpdatedPackageSpecs := Dictionary new.
			ar at: 3 put: updatedPackageSpecsMap.
			reversed := aConfig project attributes reverse.
			reversed
				do: [ :attribute | 
					| vs |
					(vs := (ar at: 1) at: attribute ifAbsent: [  ]) ~~ nil
						ifTrue: [ 
							updatedPackageSpecs := forceUpdate
								ifTrue: [ vs forceUpdatedPackageSpecs ]
								ifFalse: [ vs updatedPackageSpecs ].
							updatedPackageSpecs associations
								do: [ :assoc | 
									| filename |
									(filename := seenUpdatedPackageSpecs at: assoc key ifAbsent: [  ]) == nil
										ifTrue: [ 
											assoc value == #uptodate
												ifTrue: [ 
													"#uptodate means that the spec is up-to-date and we mark it as
										 seen so that the spec is not update for a 'later' spec"
													seenUpdatedPackageSpecs at: assoc key put: #uptodate ]
												ifFalse: [ seenUpdatedPackageSpecs at: assoc key put: assoc value file ] ]
										ifFalse: [ 
											"if the spec was already seen as up-to-date or the file is the same as 
								 the one already seen don't propogate the file"
											(filename == #uptodate or: [ assoc value == #uptodate or: [ filename = assoc value file ] ])
												ifTrue: [ updatedPackageSpecs removeKey: assoc key ] ] ].
							updatedPackageSpecsMap at: attribute put: updatedPackageSpecs ] ].	"clear out #uptodate markers"
			updatedPackageSpecsMap
				valuesDo: [ :d | 
					d associations
						do: [ :assoc | 
							assoc value == #uptodate
								ifTrue: [ d removeKey: assoc key ] ] ].	"remove shadowed packages"
			1 to: reversed size do: [ :index | 
				| attribute d |
				attribute := reversed at: index.
				((d := updatedPackageSpecsMap at: attribute ifAbsent: [  ]) ~~ nil and: [ d keys size > 0 ])
					ifTrue: [ 
						index + 1 to: reversed size do: [ :shadowIndex | 
							d
								keysDo: [ :key | 
									| dict |
									(dict := updatedPackageSpecsMap at: (reversed at: shadowIndex) ifAbsent: [  ]) ~~ nil
										ifTrue: [ dict removeKey: key ifAbsent: [  ] ] ] ] ] ].
			updatedPackageSpecsMap keys
				do: [ :key | 
					| d |
					d := updatedPackageSpecsMap at: key.
					d isEmpty
						ifTrue: [ updatedPackageSpecsMap removeKey: key ] ].	"ready to generate source for method"
			generateBlock
				value: selector
				value: pragmaMap
				value: ar
				value: updatedPackageSpecsMap ]! !

!MetacelloVersionConstructor methodsFor: 'deprecated' stamp: 'DaleHenrichs 12/4/2010 09:53'!
spawnPackageMethodIn: aConfig category: methodCategory named: newSelector sourceVersion: sourceVersionString targetVersion: targetVersionString blessing: blessing

	self deprecated: 'see MetacelloToolBox class>>createBaseline:for:from:description: for replacement method'.
	self 
		prepareForMethodUpdate: aConfig 
		sourceVersion: sourceVersionString 
		forceUpdate: blessing ~~ #baseline
		generating: [:selector :pragmaMap :ar :updatedPackageSpecsMap | | strm |
			strm := WriteStream on: String new.
			strm 
				nextPutAll: newSelector asString, ' spec'; cr;
				tab; nextPutAll: 
						'<version: ', 
						targetVersionString printString, 
						' imports: #(', sourceVersionString printString, 
						')>';cr.
			(ar at: 2) do: [:attribute | | vs d |
				vs := (ar at: 1) at: attribute.
				(d := updatedPackageSpecsMap at: attribute ifAbsent: []) ~~ nil
					ifTrue: [ 
						vs packagesSpec list do: [:member | | x |
							x := d at: member spec name ifAbsent: [].
						 	member spec updateForSpawnMethod: x ]]
					ifFalse: [
						vs packagesSpec list do: [:member |
							member spec updateForSpawnMethod: member spec copy ]].
				strm cr; tab; nextPutAll: 'spec for: ', attribute printString, ' do: ['; cr.
				attribute == #common
					ifTrue: [
						vs 
							author: MetacelloPlatform current authorName;
							timestamp: MetacelloPlatform current timestamp.
						blessing ~~ nil
							ifTrue: [ vs blessing: blessing ]].
				vs configSpawnMethodOn: strm indent: 2.
				strm nextPutAll: '].'].
				(aConfig class	
					compile: strm contents
					classified: methodCategory) == nil 
						ifTrue: [ self error: 'Error compiling the method' ]].
	^true
! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 12:28'!
specResolverBlock
	^ [ :versionSpec :pragma | 
	(pragma argumentAt: 1) = versionSpec versionString
		ifTrue: [ 
			self evaluatePragma: pragma.
			self project attributes
				do: [ :attribute | 
					| blockList |
					(blockList := self attributeMap at: attribute ifAbsent: [  ]) ~~ nil
						ifTrue: [ blockList do: [ :block | self with: versionSpec during: block ] ] ] ] ]! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 12:28'!
symbolicVersionResolverBlock
	^ [ :symbolicVrsn :pragma | 
	| result |
	result := nil.
	(pragma argumentAt: 1) = symbolicVrsn
		ifTrue: [ 
			self symbolicVersion: symbolicVrsn.
			self evaluatePragma: pragma.
			self project attributes
				do: [ :attribute | 
					| versionString |
					versionString := self attributeMap at: attribute ifAbsent: [  ].
					versionString ~~ nil
						ifTrue: [ result := versionString ] ] ].
	result ]! !

!MetacelloVersionConstructor methodsFor: 'deprecated' stamp: 'DaleHenrichs 12/4/2010 09:54'!
updatePackageMethodIn: aConfig sourceVersion: sourceVersionString

	self deprecated: 'see MetacelloToolBox class>>updateDevelopment:for:updateProjects:description: for replacement method'.
	self 
		prepareForMethodUpdate: aConfig 
		sourceVersion: sourceVersionString 
		forceUpdate: false
		generating: [:selector :pragmaMap :ar :updatedPackageSpecsMap | | strm pragma |
			updatedPackageSpecsMap isEmpty ifTrue: [ ^false ].
			strm := WriteStream on: String new.
			strm 
				nextPutAll: selector asString, ' spec'; cr;
				tab; nextPutAll: '<version: ', sourceVersionString printString.
			pragma := pragmaMap at: selector.
			pragma numArgs = 2
				ifTrue: [
					strm nextPutAll: ' imports: #('.
					(pragma argumentAt: 2) do: [:versionString |
						strm nextPutAll: versionString printString; space ]].
			strm nextPutAll: ')>';cr.
			(ar at: 2) do: [:attribute | | vs d |
				vs := (ar at: 1) at: attribute.
				(d := updatedPackageSpecsMap at: attribute ifAbsent: []) ~~ nil
					ifTrue: [ 
						vs packagesSpec list do: [:member | 
							member spec file ~~ nil
								ifTrue: [ | x |
									(((x := d at: member spec name ifAbsent: []) ~~ nil) and: [ x ~~ #uptodate ])
						 				ifTrue: [ member spec file: x file ]]]].
				strm cr; tab; nextPutAll: 'spec for: ', attribute printString, ' do: ['; cr.
				attribute == #common
					ifTrue: [ 
						vs 
							author: MetacelloPlatform current authorName;
							timestamp: MetacelloPlatform current timestamp ].
				vs configMethodOn: strm indent: 2.
				strm nextPutAll: '].'].
			(aConfig class	
					compile: strm contents
					classified: (aConfig class whichCategoryIncludesSelector: pragma selector)) == nil
						ifTrue: [ self error: 'Error compiling the method' ]].
	^true
! !

!MetacelloVersionConstructor methodsFor: 'validation' stamp: 'DaleHenrichs 11/30/2010 13:25'!
validateVersionString: versionString againstSpec: versionSpec

	versionString = versionSpec versionString
		ifFalse: [ 
			MetacelloValidationNotification
				signal:
					(MetacelloValidationError
						configurationClass: self configurationClass
						reasonCode: #incorrectVersionString
						callSite: #validateVersionString:againstSpec
						explanation:
							'The version declared in the pragma ', versionString printString , ' does not match the version in the spec '
								, versionSpec versionString printString) ].
! !

!MetacelloVersionConstructor methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 09:49'!
versionImportPragmasVerifiedDefinedIn: versionMap 
	| pragmaDict |
	pragmaDict := self extractVersionImportPragmas.
	pragmaDict
		keysAndValuesDo: [:versionString :pragmaColl | pragmaColl
				do: [:pragma | (pragma argumentAt: 2)
						do: [:importedVersion | versionMap
								at: importedVersion
								ifAbsent: [pragmaDict
										at: importedVersion
										ifAbsent: [^ self error: 'The imported version:' , importedVersion printString , ' referenced from the method: ' , pragma selector printString , ' in configuration ' , configuration class printString , ' has not been defined.']]]]].
	^ pragmaDict! !

MetacelloAbstractConstructor subclass: #MetacelloVersionValidator
	instanceVariableNames: 'configurationClass exludededValidations validationReport recurse debug visited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Validation'!

MetacelloVersionValidator class
	instanceVariableNames: 'reasonCodeDescriptions'!

MetacelloVersionValidator class
	instanceVariableNames: 'reasonCodeDescriptions'!

!MetacelloVersionValidator class methodsFor: 'accessing' stamp: 'DaleHenrichs 12/17/2010 15:16'!
descriptionForReasonCode: reasonCode
	^ self reasonCodeDescriptions at: reasonCode ifAbsent: [ self error: 'Unknown reasonCode: ' , reasonCode printString ]! !

!MetacelloVersionValidator class methodsFor: 'private' stamp: 'DaleHenrichs 1/24/2011 12:41'!
populateReasonCodeDescriptions

	| dict |
	dict := Dictionary new.
	"Warnings"
	dict at: #onlyBaselineVersion put: 'one or more baseline versions have been defined, but no non-baseline versions are defined.'.
	"Critical Warnings"
	dict at: #duplicateVersionDefinitions put: 'there are multiple pragma methods specifying the same version.'.
	dict at: #packageNameMismatch put: 'the name in the packageSpec does not match the name of the mcz file.'.
	dict at: #projectClassNameFileMismatch put: 'the class name of the configuration does not match the mcz file containing the configuration.'.
	"Errors"
	dict at: #cannotResolveVersion put: 'the version (project reference or symbolic version) was not found in the specified configuration.'.
	dict at: #duplicateNames put: 'multiple independent definitions for an entity with same name (project, package, or group).'.
	dict at: #incompleteProjectSpec put: 'missing required fields in project reference (className and/or repository).'.
	dict at: #incorrectVersionString put: 'the version declared in pragma doesn''t match version in versionSpec.'.
	dict at: #invalidDoItSelector put: 'doit select must be a Symbol.'.
	dict at: #invalidVersionString put: 'versionString must be a String.'.
	dict at: #missingVersionImport put: 'version specified in import pragma not defined in configuration.'.
	dict at: #noVersionsDefined put: 'no usable baseline or version defined in configuration ... configuration cannot be loaded.'.
	dict at: #projectCreationError put: 'error occured while resolving project reference.'.
	dict at: #shadowedNames put: 'name duplication between packages and projects.'.
	dict at: #versionCompositionError put: 'error while creating versionSpec from pragmas.'.
	^dict! !

!MetacelloVersionValidator class methodsFor: 'accessing' stamp: 'DaleHenrichs 12/17/2010 14:50'!
reasonCodeDescriptions

	reasonCodeDescriptions ifNil: [ reasonCodeDescriptions := self populateReasonCodeDescriptions ].
	^reasonCodeDescriptions! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:39'!
validateConfiguration: configurationClass

	^self validateConfiguration: configurationClass debug: #() recurse: false! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 11/24/2010 09:02'!
validateConfiguration: configurationClass debug: debugList recurse: aBool
	^ ((self new)
		configurationClass: configurationClass;
		debug: debugList;
		recurse: aBool;
		yourself) validate! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:39'!
validateConfiguration: configurationClass recurse: aBool

	^self validateConfiguration: configurationClass debug: #() recurse: aBool! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:40'!
validateProject: aMetacelloProject

	^self validateProject: aMetacelloProject debug: #() recurse: false! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 11/24/2010 09:01'!
validateProject: aMetacelloProject debug: debugList recurse: aBool
	^ ((self new)
		recurse: aBool;
		debug: debugList;
		configurationClass: aMetacelloProject configuration class;
		yourself) validateProject: aMetacelloProject! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:40'!
validateProject: aMetacelloProject recurse: aBool

	^self validateProject: aMetacelloProject debug: #() recurse: aBool! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:43'!
validateProject: aMetacelloProject version: versionString

	^self validateProject: aMetacelloProject version: versionString debug: #() recurse: false
! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:43'!
validateProject: aMetacelloProject version: versionString debug: debugList

	^self validateProject: aMetacelloProject version: versionString debug: debugList recurse: false
! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:42'!
validateProject: aMetacelloProject version: versionString debug: debugList recurse: aBool

	^ ((self new)
		configurationClass: aMetacelloProject configuration class;
		debug: debugList;
		recurse: aBool;
		yourself) validateProject: aMetacelloProject version: versionString! !

!MetacelloVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/4/2010 08:41'!
validateProject: aMetacelloProject version: versionString debug: debugList recurse: aBool visited: visitied

	^(self new
		configurationClass: aMetacelloProject configuration class;
		debug: debugList;
		recurse: aBool;
		visited: visitied;
		yourself) validateProject: aMetacelloProject version: versionString! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 11:42'!
configurationClass
	^ configurationClass! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 11:41'!
configurationClass: anObject
	configurationClass := anObject! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 12/17/2010 13:04'!
criticalWarningReasonCodes
	^ #(#packageNameMismatch #projectClassNameFileMismatch #duplicateVersionDefinitions)! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/24/2010 08:59'!
debug

	debug == nil ifTrue: [ debug := #() ].
	^ debug! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/24/2010 09:00'!
debug: aCollection
	"Any combination of: #error, #criticalWarning, #warning"

	debug := aCollection! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/30/2010 11:51'!
errorReasonCodes
	^ #(#duplicateNames #shadowedNames #invalidDoItSelector #invalidVersionString #missingVersionImport #projectCreationError #noVersionsDefined #cannotResolveVersion #incompleteProjectSpec #incorrectVersionString #versionCompositionError)! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/30/2010 13:17'!
exludededValidations

	exludededValidations == nil ifTrue: [ exludededValidations := self extractExcludedValidations ].
	^exludededValidations! !

!MetacelloVersionValidator methodsFor: 'pragma extraction' stamp: 'DaleHenrichs 11/30/2010 14:33'!
extractExcludedValidations

	| exclusionDict |
	exclusionDict := Dictionary new.
	(Pragma 
		allNamed: #excludedValidationIssues:
		in: self configurationClass) do: [:pragma | | exclusions |
			exclusions := pragma argumentAt: 1.
			1 to: exclusions size by: 2 do: [:index |
			exclusionDict 
				at: (exclusions at: index) 
				put: (exclusions at: index + 1) ]].
	^exclusionDict! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/30/2010 13:30'!
recordValidationCriticalWarning: aString callSite: callSite reasonCode: aSymbol

	^self recordValidationCriticalWarning: aString versionString: nil callSite: callSite reasonCode: aSymbol
! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/30/2010 13:28'!
recordValidationCriticalWarning: aString versionString: versionString callSite: callSite reasonCode: aSymbol
	"reasonCodes:
		#packageNameMismatch
		#projectClassNameFileMismatch
		#duplicateVersionDefinitions
		#duplicateAttributeBlocks
	"

	(self criticalWarningReasonCodes includes: aSymbol)
		ifFalse: [ self error: 'Unknown critical warning reason code' ].
	((self exludededValidations at: versionString ifAbsent: [ #() ]) includes: aSymbol)
		ifTrue: [ ^self ].
	(self debug includes: #criticalWarning) ifTrue: [ self halt: 'Debug triggered for critical warning: ', aString ].
	self validationReport
		add:
			(MetacelloValidationCriticalWarning
				configurationClass:
					(self recurse
						ifTrue: [ self configurationClass ]
						ifFalse: [ nil ])
				reasonCode: aSymbol
				callSite: callSite
				explanation: aString)! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 12/3/2010 10:50'!
recordValidationError: aString callSite: callSite reasonCode: aSymbol

	^self recordValidationError: aString versionString: nil callSite: callSite reasonCode: aSymbol
! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/30/2010 13:28'!
recordValidationError: aString versionString: versionString callSite: callSite reasonCode: aSymbol
	"reasonCodes:
		#noVersionForSymbolicVersion
		#duplicateNames
		#shadowedNames
		#invalidDoItSelector
		#invalidVersionString
		#missingVersionImport
		#projectCreationError
		#noVersionsDefined
		#cannotResolveVersion
		#incompleteProjectSpec
		#incorrectVersionString
	"

	(self errorReasonCodes includes: aSymbol)
		ifFalse: [ self error: 'Unknown error reason code' ].
	((self exludededValidations at: versionString ifAbsent: [ #() ]) includes: aSymbol)
		ifTrue: [ ^self ].
	(self debug includes: #error) ifTrue: [ self halt: 'Debug triggered for error: ', aString ].
	self validationReport
		add:
			(MetacelloValidationError
				configurationClass:
					(self recurse
						ifTrue: [ self configurationClass ]
						ifFalse: [ nil ])
				reasonCode: aSymbol
				callSite: callSite
				explanation: aString)! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/30/2010 13:30'!
recordValidationWarning: aString callSite: callSite reasonCode: aSymbol

				
	^self recordValidationWarning: aString versionString: nil callSite: callSite reasonCode: aSymbol
! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/30/2010 13:29'!
recordValidationWarning: aString versionString: versionString callSite: callSite reasonCode: aSymbol
	"reasonCodes:
		#onlyBaselineVersion
		#noVersionSpecified
	"

	(self warningReasonCodes includes: aSymbol)
		ifFalse: [ self error: 'Unknown warning reason code' ].
	((self exludededValidations at: versionString ifAbsent: [ #() ]) includes: aSymbol)
		ifTrue: [ ^self ].
	(self debug includes: #warning) ifTrue: [ self halt: 'Debug triggered for critical warning: ', aString ].
	self validationReport
		add:
			(MetacelloValidationWarning
				configurationClass:
					(self recurse
						ifTrue: [ self configurationClass ]
						ifFalse: [ nil ])
				reasonCode: aSymbol
				callSite: callSite
				explanation: aString)! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 09:56'!
recurse
	recurse == nil ifTrue: [ recurse := false ].
	^ recurse! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 09:39'!
recurse: anObject
	recurse := anObject! !

!MetacelloVersionValidator methodsFor: 'validation' stamp: 'DaleHenrichs 11/4/2010 10:36'!
validate
	"Issue 5: 
		[]no shadowing of names across project/package/group boundaries
	 Issue 6: 
		[]package version supplied for each package
		[]no released (stable/bleedingEdge) versions (only development version)
		package spec used instead of project spec in baseline (ConfigurationOfPharo-DaleHenrichs.50)
	Issue 20:
		[]pre and post load doits must be symbols, not blocks
	Others:
		[]symbolic versions can be resolved.
		[]Ensure that versions are Strings and symbolic versions are symbols.
	 	[]Ensure that imported versions are defined."

	self validatePragmas.
	^self validateProject! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/3/2010 16:46'!
validateBaselineVersionSpec: versionSpec

	self subclassResponsibility! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 12/21/2010 11:48'!
validateDoIts: aSpec versionString: versionString errorMessage: errorMessage
	| ar |
	ar := {
		#preLoadDoIt.	'preLoadDoIt selector for '.
		#postLoadDoIt.	'postLoadDoIt selector for '.
	}.
	1 to: ar size by: 2 do: [ :i | 
		| selector |
		selector := (aSpec perform: (ar at: i)) value.
		selector ~~ nil
			ifTrue: [ 
				selector isSymbol
					ifFalse: [ 
						self
							recordValidationError: (ar at: i + 1) , errorMessage , ' is not a symbol'
							versionString: versionString
							callSite: #validateDoIts:versionString:errorMessage:
							reasonCode: #invalidDoItSelector ] ] ]! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/30/2010 13:37'!
validatePragmas
	"Ensure that versions are Strings and symbolic versions are symbols.
	 Ensure that imported versions are defined"

	| versionPragmas versionImportPragmas symbolicVersionPragmas versionStrings |
	versionPragmas := self extractVersionPragmas.
	versionImportPragmas := self extractVersionImportPragmas.
	symbolicVersionPragmas := self extractSymbolicVersionPragmas.
	versionStrings := Set new.
	versionPragmas keys , versionImportPragmas keys , symbolicVersionPragmas keys
		do: [ :versionString | 
			(versionStrings includes: versionString)
				ifTrue: [ 
					self
						recordValidationCriticalWarning: 'version ' , versionString printString , ' is defined multiple times.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #duplicateVersionDefinitions ]
				ifFalse: [ versionStrings add: versionString ] ].
	versionPragmas
		keysAndValuesDo: [ :versionString :pragmaList | 
			versionString isString
				ifFalse: [ 
					self
						recordValidationError: 'version ' , versionString printString , ' is not a String.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #invalidVersionString ].
			pragmaList size > 1
				ifTrue: [ 
					self
						recordValidationCriticalWarning: 'version ' , versionString printString , ' is defined multiple times.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #duplicateVersionDefinitions ] ].
	symbolicVersionPragmas
		keysAndValuesDo: [ :versionString :pragmaList | 
			versionString isSymbol
				ifFalse: [ 
					self
						recordValidationError: 'symbolic version ' , versionString printString , ' is not a Symbol.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #invalidVersionString ].
			pragmaList size > 1
				ifTrue: [ 
					self
						recordValidationCriticalWarning: 'version ' , versionString printString , ' is defined multiple times.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #duplicateVersionDefinitions ] ].
	versionImportPragmas
		keysAndValuesDo: [ :versionString :pragmaList | 
			versionString isString
				ifFalse: [ 
					self
						recordValidationError: 'version ' , versionString printString , ' is not a String.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #invalidVersionString ].
			pragmaList size > 1
				ifTrue: [ 
					self
						recordValidationCriticalWarning: 'version ' , versionString printString , ' is defined multiple times.'
						versionString: versionString
						callSite: #validatePragmas
						reasonCode: #duplicateVersionDefinitions ].
			pragmaList
				do: [ :versionImportPragma | 
					(versionImportPragma arguments at: 2)
						do: [ :importedVersionString | 
							(versionStrings includes: importedVersionString)
								ifFalse: [ 
									self
										recordValidationError:
											'version ' , importedVersionString printString , ' referenced in import list of version ' , versionString printString
												, ' has not been defined.'
										versionString: versionString
										callSite: #validatePragmas
										reasonCode: #missingVersionImport ] ] ] ]! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/30/2010 13:46'!
validateProject
	| project |
	project := self
		validateProjectCreationFrom: self configurationClass
		onError: [ :ex | 
			self
				recordValidationError:
					'Error creating project: ' , ex description , ' to reproduce evalutate the following: '''
						, self configurationClass name asString , ' project'''
				callSite: #validateProject
				reasonCode: #projectCreationError.
			^ self validationReport ].
	^ self validateProject: project! !

!MetacelloVersionValidator methodsFor: 'validation' stamp: 'DaleHenrichs 11/30/2010 13:49'!
validateProject: project
	| hasNoBaseline hasNoVersion |
	(self visited includes: project configuration class)
		ifTrue: [ ^ self validationReport ].
	self visited add: project configuration class.
	hasNoBaseline := hasNoVersion := true.
	project versions
		do: [ :version | 
			| spec |
			spec := version spec.
			[ 
			spec blessing value == #baseline
				ifTrue: [ 
					hasNoBaseline := false.
					self validateBaselineVersionSpec: spec ]
				ifFalse: [ 
					hasNoVersion := false.
					self validateVersionSpec: spec ] ]
				on: Error
				do: [ :ex | 
					self
						recordValidationError: 'Error composing version ' , version versionString printString , ': ' , ex description
						versionString: version versionString
						callSite: #validateProject:
						reasonCode: #versionCompositionError ] ].
	project symbolicVersionMap keys
		do: [ :symbolicVersion | 
			| version |
			version := [ project version: symbolicVersion ]
				on: Error , MetacelloSymbolicVersionNotDefinedError
				do: [ :ex | 
					"MetacelloSymbolicVersionNotDefinedError are explicitly not defined, so are not validation errors"
					(ex isKindOf: MetacelloSymbolicVersionNotDefinedError)
						ifFalse: [ 
							self
								recordValidationError:
									'symbolic version ' , symbolicVersion printString , ' does not resolve to a literal version.'
								callSite: #validatePragmas
								reasonCode: #cannotResolveVersion ].
					ex return: nil ].
			version ~~ nil
				ifTrue: [ self validateVersionSpecForSymbolicVersion: version spec symbolicVersion: symbolicVersion ] ].
	hasNoVersion
		ifTrue: [ 
			hasNoBaseline
				ifTrue: [ 
					self
						recordValidationError: 'No usable baseline or versions defined.'
						callSite: #validatePragmas
						reasonCode: #noVersionsDefined ]
				ifFalse: [ 
					self
						recordValidationWarning: 'Only baseline defined (no version defined).'
						callSite: #validatePragmas
						reasonCode: #onlyBaselineVersion ] ].
	^ self validationReport! !

!MetacelloVersionValidator methodsFor: 'validation' stamp: 'DaleHenrichs 12/21/2010 10:39'!
validateProject: project version: versionString
	| version spec |
	(self visited includes: project configuration class)
		ifTrue: [ ^ self validationReport ].
	self visited add: project configuration class.
	[ version := project version: versionString ]
		on: Error
		do: [ :ex | 
			self
				recordValidationError: 'Could not resolve version ' , versionString printString , ' due to error: ' , ex description
				versionString: versionString
				callSite: #validateProject:version:
				reasonCode: #cannotResolveVersion.
			^ self validationReport ].
	spec := version spec.
	[ 
	spec blessing value == #baseline
		ifTrue: [ self validateBaselineVersionSpec: spec ]
		ifFalse: [ self validateVersionSpec: spec ] ]
		on: Error
		do: [ :ex | 
			self
				recordValidationError: 'Error composing version ' , version versionString printString , ': ' , ex description
				versionString: version versionString
				callSite: #validateProject:version:
				reasonCode: #versionCompositionError ].
	^ self validationReport! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 12/4/2010 09:55'!
validateProjectCreationFrom: aConfigurationClass onError: aBlock
	[ ^ aConfigurationClass project ]
		on: Error , MetacelloValidationNotification
		do: [ :ex | 
			(ex isKindOf: MetacelloValidationNotification)
				ifTrue: [ 
					self validationReport add: ex issue.
					ex resume ].
			^ aBlock value: ex ]! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 12/4/2010 10:53'!
validateProjectVersion: versionString
	| project |
	project := self
		validateProjectCreationFrom: self configurationClass
		onError: [ :ex | 
			self
				recordValidationError:
					'Error creating project: ' , ex description , ' to reproduce evalutate the following: '''
						, self configurationClass name asString , ' project'''
				callSite: #validateProject
				reasonCode: #projectCreationError.
			^ self validationReport ].
	^ self validateProject: project version: versionString! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 10:44'!
validateVersionSpec: versionSpec

	self subclassResponsibility! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/12/2010 10:44'!
validateVersionSpecForSymbolicVersion: versionSpec symbolicVersion: symbolicVersionString

	self subclassResponsibility! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 14:02'!
validationReport
	
	validationReport == nil ifTrue: [ validationReport := OrderedCollection new ].
	^ validationReport! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 14:01'!
validationReport: anObject
	validationReport := anObject! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/08/2010 14:45'!
visited

	visited == nil ifTrue: [ visited := IdentitySet new ].
	^visited! !

!MetacelloVersionValidator methodsFor: 'accessing' stamp: 'DaleHenrichs 11/08/2010 14:49'!
visited: anIdentitySet

	visited := anIdentitySet! !

!MetacelloVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/30/2010 11:45'!
warningReasonCodes
	^ #(#onlyBaselineVersion )! !

Object subclass: #MetacelloMethodSection
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloMethodSection methodsFor: 'accessing' stamp: 'dkh 9/7/2012 10:45'!
attribute
    self deprecated: 'Use attributes instead'.
    self attributes size > 1
        ifTrue: [ self error: 'invalid use of attribute' ].
    self attributes isEmpty
        ifTrue: [ ^ nil ].
    ^ self attributes first! !

!MetacelloMethodSection methodsFor: 'accessing' stamp: 'dkh 9/7/2012 10:49'!
attribute: anObject
    self deprecated: 'Use attributes: instead'.
    self attributes size > 1
        ifTrue: [ self error: 'invalid use of attribute:' ].
    attributes := OrderedCollection with: anObject! !

!MetacelloMethodSection methodsFor: 'printing' stamp: 'dkh 9/12/2012 09:46'!
attributePrintString
    | stream |
    stream := WriteStream on: String new.
    self attributes size = 1
        ifTrue: [ stream nextPutAll: '#' , attributes first asString printString ]
        ifFalse: [ 
            stream nextPutAll: '#('.
            self attributes
                do: [ :attribute | 
                    stream
                        nextPutAll: '#' , attribute asString printString;
                        space ].
            stream nextPut: $) ].
    ^ stream contents! !

!MetacelloMethodSection methodsFor: 'accessing' stamp: 'dkh 9/7/2012 06:42'!
attributes
    attributes ifNil: [ attributes := OrderedCollection new ].
    ^ attributes! !

!MetacelloMethodSection methodsFor: 'accessing' stamp: 'dkh 9/8/2012 05:41'!
attributes: aCollectionOrSymbol
    attributes := aCollectionOrSymbol asMetacelloAttributeList! !

!MetacelloMethodSection methodsFor: 'testing' stamp: 'dkh 9/13/2012 19:12'!
includesAttributeFrom: attributeCollection
    ^ (attributeCollection asSet intersection: self attributes asSet) notEmpty! !

MetacelloMethodSection subclass: #MetacelloSymbolicVersionSpec
	instanceVariableNames: 'versionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloSymbolicVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 10:12'!
versionString
	^ versionString! !

!MetacelloSymbolicVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 10:12'!
versionString: anObject
	versionString := anObject! !

MetacelloMethodSection subclass: #MetacelloVersionMethodSection
	instanceVariableNames: 'block versionSpec parent methodSections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
addMethodSection: methodSection

	methodSection parent: self.
	self methodSections add: methodSection! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
attributeOrPath
    ^ self parent == nil
        ifTrue: [ 
            self attributes size == 1
                ifTrue: [ self attributes first ]
                ifFalse: [ self attributes ] ]
        ifFalse: [ self attributePath ]! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
attributePath
    | path |
    path := MetacelloMethodSectionPath with: self attributes.
    ^ self parent == nil
        ifTrue: [ path ]
        ifFalse: [ self parent attributePath , path ]! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
block
	^ block! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
block: anObject
	block := anObject! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
methodSections

	methodSections ifNil: [ methodSections := OrderedCollection new ].
	^methodSections! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
parent
	^ parent! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
parent: anObject
	parent := anObject! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
topParent
	self parent == nil
		ifTrue: [ ^ self ].
	^ self parent topParent! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
versionSpec
	^ versionSpec! !

!MetacelloVersionMethodSection methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
versionSpec: anObject
	versionSpec := anObject! !

Object subclass: #MetacelloMethodSpec
	instanceVariableNames: 'project selector category versionString methodSections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 01:21'!
category
	^ category! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 01:21'!
category: anObject
	category := anObject! !

!MetacelloMethodSpec methodsFor: 'method generation' stamp: 'DaleHenrichs 11/14/2010 01:47'!
compileMethod

	(project configuration class
		compile: self methodSource
		classified: self category) == nil
		ifTrue: [ self error: 'Error compiling the method' ]! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 01:36'!
methodSections

	methodSections == nil ifTrue: [ methodSections := OrderedCollection new ].
	^ methodSections! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 01:35'!
methodSections: anObject
	methodSections := anObject! !

!MetacelloMethodSpec methodsFor: 'method generation' stamp: 'DaleHenrichs 11/14/2010 01:44'!
methodSource

	self subclassResponsibility! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 01:51'!
project
	^ project! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 01:51'!
project: anObject
	project := anObject! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 00:45'!
selector
	^ selector! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 00:45'!
selector: anObject
	selector := anObject! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/14/2010 00:46'!
versionString
	^ versionString! !

!MetacelloMethodSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/19/2010 10:36'!
versionString: aStringOrSymbol
	versionString := aStringOrSymbol! !

MetacelloMethodSpec subclass: #MetacelloSymbolicVersionMethodSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloSymbolicVersionMethodSpec methodsFor: 'adding' stamp: 'dkh 9/9/2012 07:33'!
addMethodSection: attribute versionString: aString
    self methodSections
        add:
            (MetacelloSymbolicVersionSpec new
                attributes: attribute asMetacelloAttributeList;
                versionString: aString;
                yourself)! !

!MetacelloSymbolicVersionMethodSpec methodsFor: 'method generation' stamp: 'dkh 9/7/2012 10:44'!
methodSource
    | strm |
    strm := WriteStream on: String new.
    self symbolicMethodSelectorAndPragma: self selector symbolicVersionSymbol: self versionString on: strm.
    (self methodSections asArray sort: [ :a :b | a attributes first <= b attributes first ])
        do: [ :methodSection | 
            | vs |
            strm
                cr;
                tab;
                nextPutAll: 'spec for: ' , methodSection attributePrintString , ' version: '.
            vs := methodSection versionString.
            vs isSymbol
                ifTrue: [ strm nextPut: $# ].
            strm
                nextPutAll: vs asString printString , '.';
                cr ].
    ^ strm contents! !

!MetacelloSymbolicVersionMethodSpec methodsFor: 'method generation' stamp: 'dkh 6/5/2012 19:01:24'!
symbolicMethodSelectorAndPragma: aSelector symbolicVersionSymbol: symbolicVersionSymbol on: strm
	strm
		nextPutAll: aSelector asString , ' spec';
		cr;
		tab;
		nextPutAll: '<symbolicVersion: #' , symbolicVersionSymbol asString printString;
		nextPutAll: '>';
		cr! !

!MetacelloSymbolicVersionMethodSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
versionString: aStringOrSymbol

	aStringOrSymbol isSymbol ifFalse: [ self error: 'Version symbol ', aStringOrSymbol printString, ' for symbolic version method must be a Symbol' ].
	super versionString: aStringOrSymbol! !

MetacelloMethodSpec subclass: #MetacelloVersionMethodSpec
	instanceVariableNames: 'imports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Constructors'!

!MetacelloVersionMethodSpec methodsFor: 'adding' stamp: 'dkh 6/5/2012 19:01:24'!
addMethodSection: attributePath versionSpec: versionSpec
    | attributeList methodSection index sections found |
    attributeList := attributePath last.
    methodSection := MetacelloVersionMethodSection new
        attributes: attributeList;
        versionSpec: versionSpec;
        yourself.
    attributePath size > 1
        ifTrue: [ 
            index := 1.
            sections := self methodSections.
            found := true.
            [ found ]
                whileTrue: [ 
                    found := false.
                    sections
                        do: [ :ms | 
                            ms attributes = (attributePath at: index)
                                ifTrue: [ 
                                    index == (attributePath size -1)
                                        ifTrue: [ 
                                            ms methodSections add: methodSection.
                                            ^ self ].
                                    sections := ms methodSections.
                                    index := index + 1.
                                    found := true ] ] ].
            self error: 'Method section for attribute: ' , (attributePath at: index) printString , ' not found.' ]
        ifFalse: [ self methodSections add: methodSection ]! !

!MetacelloVersionMethodSpec methodsFor: 'adding' stamp: 'dkh 9/6/2012 10:03:17'!
findMethodSection: attributeOrPath sectionIndex: sectionIndex
    | attributePath index sections found |
    attributePath := attributeOrPath asMetacelloAttributePath.
    index := 1.
    sections := self methodSections.
    found := true.
    [ found ]
        whileTrue: [ 
            found := false.
            sections
                do: [ :ms | 
                    ms attributes = (attributePath at: index)
                        ifTrue: [ 
                            index == attributePath size
                                ifTrue: [ ^ ms ].
                            sections := ms methodSections.
                            index := index + 1.
                            found := true ] ] ].
    self error: 'Method section for attribute: ' , attributePath printString , ' not found.'! !

!MetacelloVersionMethodSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
imports
	imports == nil ifTrue: [ imports := #() ].
	^ imports! !

!MetacelloVersionMethodSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
imports: anObject
	imports := anObject! !

!MetacelloVersionMethodSpec methodsFor: 'private' stamp: 'dkh 6/5/2012 19:01:24'!
methodSection: methodSection pre: preBlock last: last post: postBlock indent: indent
	| list |
	methodSection ~~ self
		ifTrue: [ preBlock value: methodSection value: indent ].
	list := methodSection methodSections.
	1 to: list size
		do: [ :index | | ms | 
			ms := list at: index.
			self
				methodSection: ms
				pre: preBlock
				last: index ~= list size
				post: postBlock
				indent: indent + 1 ].
	methodSection ~~ self
		ifTrue: [ postBlock value: methodSection value: indent value: last ]! !

!MetacelloVersionMethodSpec methodsFor: 'method generation' stamp: 'dkh 6/5/2012 19:01:24'!
methodSelectorAndPragma: aSelector imports: importList versionString: aString on: strm
	strm
		nextPutAll: aSelector asString , ' spec';
		cr;
		tab;
		nextPutAll: '<version: ' , aString printString.
	importList notEmpty
		ifTrue: [ 
			strm nextPutAll: ' imports: #('.
			importList
				do: [ :importVersionString | 
					strm
						nextPutAll: importVersionString printString;
						space ].
			strm nextPut: $) ].
	strm
		nextPutAll: '>';
		cr! !

!MetacelloVersionMethodSpec methodsFor: 'method generation' stamp: 'dkh 6/5/2012 19:01:24'!
methodSource
    | strm |
    strm := WriteStream on: String new.
    self
        methodSelectorAndPragma: self selector
        imports: self imports
        versionString: self versionString
        on: strm.
    self
        methodSection: self
        pre: [ :methodSection :indent | 
            strm
                cr;
                tab: indent;
                nextPutAll: 'spec for: ' , methodSection attributePrintString , ' do: [';
                cr.
            methodSection versionSpec configMethodOn: strm last: methodSection methodSections isEmpty indent: indent + 1 ]
        last: false
        post: [ :methodSection :indent :last | 
            strm nextPutAll: ' ].'.
            (last or: [ indent = 1 or: [ methodSection methodSections isEmpty and: [ indent = 1 ] ] ])
                ifTrue: [ strm cr ] ]
        indent: 0.
    ^ strm contents! !

!MetacelloVersionMethodSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
versionString: aStringOrSymbol

	aStringOrSymbol isSymbol ifTrue: [ self error: 'Version string ', aStringOrSymbol printString, ' for version method must be a String' ].
	super versionString: aStringOrSymbol! !

Object subclass: #MetacelloPlatform
	instanceVariableNames: 'bypassProgressBars bypassGoferLoadUpdateCategories'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Metacello-Core-Model'!

!MetacelloPlatform class methodsFor: 'accessing' stamp: 'dkh 7/24/2009 15:21'!
current
	Current
		ifNil: [Current := MetacelloPlatform new].
	^ Current! !

!MetacelloPlatform class methodsFor: 'initialize-release' stamp: 'dkh 7/24/2009 15:29'!
initialize
	"MetacelloPlatform initialize"
	"MetacelloGemStonePlatform initialize"
	"MetacelloPharoPlatform initialize"
	"MetacelloSqueakPlatform initialize"

	Current := self new! !

!MetacelloPlatform methodsFor: 'utilities' stamp: 'dkh 10/28/2009 10:53'!
authorName

	Smalltalk at: #Author ifPresent: [:cl | ^cl perform: #initials ].
	^'no developer initials'! !

!MetacelloPlatform methodsFor: 'utilities' stamp: 'dkh 1/5/2011 16:47'!
authorName: aString
	"Primarily used for testing"

	self subclassResponsibility! !

!MetacelloPlatform methodsFor: 'accessing' stamp: 'DaleHenrichs 12/18/2010 13:37'!
bypassGoferLoadUpdateCategories

	bypassGoferLoadUpdateCategories == nil ifTrue: [ bypassGoferLoadUpdateCategories := false ].
	^ bypassGoferLoadUpdateCategories! !

!MetacelloPlatform methodsFor: 'accessing' stamp: 'DaleHenrichs 12/18/2010 13:37'!
bypassGoferLoadUpdateCategories: anObject
	bypassGoferLoadUpdateCategories := anObject! !

!MetacelloPlatform methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 19:24'!
bypassProgressBars

	bypassProgressBars == nil ifTrue: [ bypassProgressBars := false ].
	^ bypassProgressBars! !

!MetacelloPlatform methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 19:24'!
bypassProgressBars: anObject
	bypassProgressBars := anObject! !

!MetacelloPlatform methodsFor: 'caching' stamp: 'dkh 4/6/2011 23:14'!
clearCurrentVersionCache
	MetacelloClearStackCacheNotification signal: #(#currentVersion #currentVersionAgainst: #currentVersionInfo)! !

!MetacelloPlatform methodsFor: 'notification' stamp: 'DaleHenrichs 3/11/2010 19:26'!
collection: aCollection do: aBlock displaying: aString

	aCollection do: aBlock! !

!MetacelloPlatform methodsFor: 'user interaction' stamp: 'dkh 8/12/2009 17:51'!
confirm: aString
	
	^(Smalltalk hasClassNamed: #UIManager)
		ifTrue: [ (Smalltalk classNamed: #UIManager) default perform: #confirm: with: aString ]
		ifFalse: [
			"throw warning and answer true, if no way to announce"
			Warning signal: aString.
			true ]! !

!MetacelloPlatform methodsFor: 'reflection' stamp: 'DaleHenrichs 11/18/2010 16:14'!
copyClass: oldClass as: newName inCategory: newCategoryName

	self subclassResponsibility! !

!MetacelloPlatform methodsFor: 'repository creation' stamp: 'CamilloBruni 10/20/2012 22:59'!
createRepository: aRepositorySpec

	| type |
	type := aRepositorySpec type.
	type = 'http'
		ifTrue: [^ MCHttpRepository
				location: aRepositorySpec description
				user: aRepositorySpec username
				password: aRepositorySpec password].
	type = 'directory'
		ifTrue: [^ MCDirectoryRepository new
				directory: aRepositorySpec description asFileReference ].
	type = 'dictionary'
		ifTrue: [	| description headerSize globalName |	
			description := aRepositorySpec description.
			headerSize := 'dictionary://' size.
			globalName := (description copyFrom: headerSize + 1 to: description size) asSymbol.
 			^Smalltalk at: globalName ifAbsent: [Smalltalk at: globalName put: MCDictionaryRepository new ]].
	^ nil! !

!MetacelloPlatform methodsFor: 'attributes' stamp: 'dkh 9/8/2011 13:47'!
defaultPlatformAttributes
	| versionString |
	Smalltalk at: #SystemVersion ifPresent: [:cl |
		versionString := cl current version.
		(versionString beginsWith: 'Pharo')
			ifTrue: [ ^ #(#squeakCommon #pharo ) ].
		(versionString beginsWith: 'Squeak')
			ifTrue: [^ #(#squeakCommon #squeak )].
		"see http://code.google.com/p/metacello/issues/detail?id=146"
		(versionString includesSubString: 'Pharo')
			ifTrue: [ ^ #(#squeakCommon #pharo ) ].
		(versionString includesSubString: 'Squeak')
			ifTrue: [^ #(#squeakCommon #squeak )].
		self error: 'Unrecognized version of Squeak/Pharo: ', versionString ].
	^ #(#gemstone )! !

!MetacelloPlatform methodsFor: 'tests' stamp: 'dkh 6/7/2011 15:58'!
defaultTimeout
	"squeak compatability"
	^60! !

!MetacelloPlatform methodsFor: 'notification' stamp: 'DaleHenrichs 03/08/2010 13:31'!
do: aBlock displaying: aString

	aBlock value! !

!MetacelloPlatform methodsFor: 'repository creation' stamp: 'tbn 6/9/2010 13:56'!
extractTypeFromDescription: description

	description == nil ifTrue: [ ^nil ].
	((description beginsWith: '/') or: [ description second = $:]) ifTrue: [ ^'directory' ].
	(description beginsWith: 'dictionary://') ifTrue: [ ^'dictionary' ].
	^'http'! !

!MetacelloPlatform methodsFor: 'reflection' stamp: 'dkh 1/16/2011 11:08'!
globalNamed: globalName

	^Smalltalk at: globalName! !

!MetacelloPlatform methodsFor: 'reflection' stamp: 'dkh 1/16/2011 11:08'!
globalNamed: globalName ifAbsent: absentBlock

	^Smalltalk at: globalName ifAbsent: absentBlock! !

!MetacelloPlatform methodsFor: 'caching' stamp: 'DaleHenrichs 9/22/2010 14:58'!
primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary

	self deprecated: 'use #primeStackCacheWith:doing:'.
	self 
		useStackCacheDuring: [:dict | | cache |
			cache := dict at: cacheName ifAbsent: [].
			cache == nil
				ifTrue: [ 
					cache := Dictionary new.
					dict at: cacheName put: cache ].
			^noArgBlock value ] 
		defaultDictionary: aDictionary! !

!MetacelloPlatform methodsFor: 'caching' stamp: 'DaleHenrichs 9/22/2010 14:26'!
primeStackCacheWith: aDictionary doing: noArgBlock

	self 
		useStackCacheDuring: [:dict | ^noArgBlock value ] 
		defaultDictionary: aDictionary! !

!MetacelloPlatform methodsFor: 'caching' stamp: 'dkh 4/6/2011 22:44'!
stackCacheFor: cacheName at: key doing: aBlock

	^self stackCacheFor: cacheName cacheClass: Dictionary at: key doing: aBlock! !

!MetacelloPlatform methodsFor: 'caching' stamp: 'dkh 4/6/2011 22:41'!
stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock

	self 
		useStackCacheDuring: [:dict | | cache |
			cache := dict at: cacheName ifAbsent: [].
			cache ~~ nil
				ifTrue: [ | value hasEntry |
					hasEntry := true.
					value := cache at: key ifAbsent: [ hasEntry := false ].
					hasEntry ifTrue: [ ^value ]]
				ifFalse: [ 
					cache := cacheClass new.
					dict at: cacheName put: cache ].
			^aBlock value: cache ] 
		defaultDictionary: nil! !

!MetacelloPlatform methodsFor: 'utilities' stamp: 'dkh 10/7/2009 10:51'!
timestamp

	^DateAndTime now printString! !

!MetacelloPlatform methodsFor: 'transactions' stamp: 'dkh 10/23/2009 11:59'!
transact: aBlock
	"On GemStone, we want to optionally abort before command execution and commit after 
	 common execution. Other plaforms don't need to do anything special.
	 Returning out of block, skips commit."
	
	aBlock value! !

!MetacelloPlatform methodsFor: 'caching' stamp: 'dkh 4/6/2011 23:24'!
useStackCacheDuring: aBlock defaultDictionary: defaultDictionary
	| dict |
	dict := MetacelloStackCacheNotification signal.
	dict == nil
		ifTrue: [ 
			dict := defaultDictionary == nil
				ifTrue: [ Dictionary new ]
				ifFalse: [ defaultDictionary ] ].
	[ ^ aBlock value: dict ]
		on: MetacelloStackCacheNotification , MetacelloClearStackCacheNotification
		do: [ :ex | 
			(ex isKindOf: MetacelloStackCacheNotification)
				ifTrue: [ ex resume: dict ].
			(ex isKindOf: MetacelloClearStackCacheNotification)
				ifTrue: [ 
					| keys |
					keys := ex cacheNames.
					keys ifNil: [ keys := dict keys ].
					keys
						do: [ :k | 
							(dict includesKey: k)
								ifTrue: [ 
									| c |
									c := dict at: k.
									c keys do: [ :ck | c removeKey: ck ].
									dict removeKey: k ] ].
					ex resume ] ]! !

Object subclass: #MetacelloProject
	instanceVariableNames: 'versionMap symbolicVersionMap loader loaderClass loadType configuration projectAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Model'!

!MetacelloProject class methodsFor: 'instance creation' stamp: 'dkh 9/4/2009 01:43'!
new

	| inst |
	inst := self basicNew.
	^inst configuration: inst; yourself! !

!MetacelloProject class methodsFor: 'instance creation' stamp: 'dkh 9/4/2009 01:43'!
on: aConfig

	^self basicNew configuration: aConfig; yourself! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 10/14/2009 16:33'!
attributes

	^(OrderedCollection with: #common)
		addAll: self platformAttributes;
		yourself
! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/2/2010 13:20'!
bleedingEdge

	^self version: #bleedingEdge! !

!MetacelloProject methodsFor: 'accessing' stamp: 'tg 8/30/2009 17:48'!
configuration
	^ configuration! !

!MetacelloProject methodsFor: 'accessing' stamp: 'tg 8/30/2009 17:48'!
configuration: anObject
	configuration := anObject! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 7/8/2011 19:56'!
currentVersion
	| cacheKey cv |
	cacheKey := self configuration class.
	^ MetacelloPlatform current
		stackCacheFor: #currentVersion
		at: cacheKey
		doing: [ :cache | 
			cv := self currentVersionAgainst: nil.
			^ cache at: cacheKey put: cv ]! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 7/11/2011 16:19'!
currentVersionAgainst: resolvedPackageAndProjectNames
	| cacheKey |
	cacheKey := resolvedPackageAndProjectNames isNil
		ifTrue: [ Array with: self configuration class with: nil ]
		ifFalse: [ Array with: self configuration class with: (resolvedPackageAndProjectNames sort: [ :a :b | a <= b ]) ].
	^ MetacelloPlatform current
		stackCacheFor: #currentVersionAgainst:
		at: cacheKey
		doing: [ :cache | 
			| cv versions latestSomethingLoaded |
			cv := nil.
			versions := self sortedAndFilteredVersions.
			versions
				do: [ :version | 
					| status matchBlock |
					status := resolvedPackageAndProjectNames isNil
						ifTrue: [ version spec isPartiallyCurrent ]
						ifFalse: [ version spec isPartiallyCurrentAgainst: resolvedPackageAndProjectNames ].
					matchBlock := [ :matchStatus | 
					cv := version copy.
					cv versionStatus: matchStatus.
					^ cache at: cacheKey put: cv ].
					status isAllLoadedToSpec: matchBlock.
					status isLoadedToSpec: matchBlock.
					status isLoadedMatchConstraints: matchBlock.
					status
						isSomethingLoaded: [ :matchStatus | 
							latestSomethingLoaded isNil
								ifTrue: [ 
									cv := version copy.
									cv versionStatus: matchStatus.
									latestSomethingLoaded := cv ] ] ].
			latestSomethingLoaded ifNotNil: [ ^ cache at: cacheKey put: latestSomethingLoaded ].
			^ cache at: cacheKey put: nil ]! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 6/18/2009 12:52'!
defaultBlessing

	^#release! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/9/2009 16:03'!
defaultLoaderClass

	^MetacelloSpecLoader! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 7/24/2009 15:37'!
defaultPlatformAttributes

	^ MetacelloPlatform current defaultPlatformAttributes! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/2/2010 16:58'!
development

	^self version: #development! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 10/7/2009 10:05'!
excludeFromLatestVersion

	^#(development broken baseline)! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 10/4/2009 12:17'!
groupSpec

	^self groupSpecClass for: self! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 10/4/2009 12:18'!
groupSpecClass

	^MetacelloGroupSpec! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/12/2010 06:43'!
hasVersion: versionString

	self version: versionString ifAbsent: [ ^false ].
	^true! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 9/10/2009 15:14'!
label

	^self configuration class name! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 01/24/2011 13:33'!
lastVersion

	| coll |
	coll := (self map values asArray sort: [:a :b | a <= b ]) asOrderedCollection.
	coll isEmpty ifTrue: [ ^nil ].
	^coll last! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/2/2010 13:27'!
latestVersion

	| excluded |
"	self deprecated: 'Please use #stableVersion instead.'.
"	self flag: 'deprecate after version 1.0'.
	excluded := self excludeFromLatestVersion.
	^(self map values select: [:version |  
		(excluded includes: version blessing) not ]) detectMax: [:version | version ]! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 8/26/2009 10:07'!
latestVersion: blessing

	^(self map values select: [:version | blessing = version blessing ]) detectMax: [:version | version ]! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 1/5/2010 10:43'!
latestVersionMatching: versionPatternString
	"Answer whether the version number of the receiver matches the given pattern string.

	 A Metacello version number is made up of version sequences delimited by the characters $. and $-.
	 The $. introduces a numeric version sequence and $- introduces an alphanumeric version sequence.
	 
	 A version pattern is made up of version pattern match sequences. also delimited by the characters $. 
	 and $-.. Each pattern match sequence is tested against the corresponding version sequence of the 
	 receiver, using the 'standard' pattern matching rules. All sequences must answer true for a match.
	
	 The special pattern sequence '?' is a match for the corresponding version sequence and all subsequent 
	 version sequences. '?' as the version pattern matches all versions. No more version pattern 
	 sequences are permitted once the '?' sequence is used. If used, it is the last version pattern
	 sequence."

	^self 
		latestVersionMatching: versionPatternString 
		includedBlessings: #()
		excludedBlessings: self excludeFromLatestVersion
! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 12/21/2009 14:04'!
latestVersionMatching: versionPatternString excludedBlessings: excluded

	^self 
		latestVersionMatching: versionPatternString 
		includedBlessings: #()
		excludedBlessings: excluded
! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 12/21/2009 13:59'!
latestVersionMatching: versionPatternString includedBlessings: included

	^self 
		latestVersionMatching: versionPatternString 
		includedBlessings: included
		excludedBlessings: self excludeFromLatestVersion
! !

!MetacelloProject methodsFor: 'versions' stamp: 'dkh 12/21/2009 14:41'!
latestVersionMatching: versionPatternString includedBlessings: included excludedBlessings: excludedBlessings

	| excluded |
	excluded := excludedBlessings asSet copy.
	excluded removeAllFoundIn: included.
	^(self map values select: [:version |
		(included isEmpty or: [ included includes: version blessing ]) 
			and: [ (excluded includes: version blessing) not 
				and: [ version versionNumber match: versionPatternString ]]])
		detectMax: [:version | version ]! !

!MetacelloProject methodsFor: 'loading' stamp: 'dkh 9/10/2009 15:09'!
load: aVersionString

	^(self version: aVersionString) load
! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 9/10/2009 13:27'!
loadType
	"#atomic or #linear"

	loadType == nil ifTrue: [ ^#atomic ].
	^loadType! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 9/10/2009 13:27'!
loadType: aSymbol
	"#atomic or #linear"

	loadType := aSymbol! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/18/2009 10:10'!
loader

	^loader! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/18/2009 10:10'!
loader: aLoader

	loader := aLoader! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/9/2009 16:04'!
loaderClass

	loaderClass == nil ifTrue: [ loaderClass := self defaultLoaderClass ].
	^loaderClass! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/9/2009 16:05'!
loaderClass: aMetacelloSpecLoader

	loaderClass := aMetacelloSpecLoader! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 6/24/2011 15:58'!
map
	versionMap ifNil: [ ^ Dictionary new ].
	^ versionMap! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 10/3/2009 17:31'!
map: aDictionary

	versionMap := aDictionary! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 10/4/2009 12:18'!
packagesSpec

	^self packagesSpecClass for: self! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 10/4/2009 12:18'!
packagesSpecClass

	^MetacelloPackagesSpec! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 10/17/2009 09:32'!
platformAttributes

	 ^self projectPlatformAttributes! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 7/28/2009 16:42'!
pragmaKeywords

	^#(version:attribute: blessing:attribute: description:attribute: required:attribute: groups:attribute: doits:attribute:)! !

!MetacelloProject methodsFor: 'printing' stamp: 'DaleHenrichs 12/7/2010 02:54'!
printOn: aStream
	| label |
	self configuration class printOn: aStream.
	aStream nextPut: $(.
	self versions
		do: [ :vrsn | 
			aStream nextPutAll: vrsn versionString.
			vrsn spec ~~ nil
				ifTrue: [ 
					(label := vrsn spec projectLabel) isEmpty
						ifFalse: [ aStream nextPutAll: ' [' , label , ']' ] ].
			aStream
				nextPut: $,;
				space ].
	aStream nextPut: $)! !

!MetacelloProject methodsFor: 'accessing' stamp: 'dkh 9/2/2009 06:02'!
project

	^self! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 9/2/2009 08:31'!
projectAttributes

	projectAttributes ~~ nil ifTrue: [ ^projectAttributes ].
	^#()! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 9/2/2009 08:31'!
projectAttributes: aList

	projectAttributes := aList! !

!MetacelloProject methodsFor: 'private' stamp: 'dkh 9/2/2009 07:38'!
projectPlatformAttributes

	| list aBlock |
	list := OrderedCollection new.
	(aBlock := self projectAttributes) ~~ nil 
		ifTrue: [ list addAll: aBlock value ].
	^self defaultPlatformAttributes, list! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 10/4/2009 12:18'!
projectReferenceSpec

	^self projectReferenceSpecClass for: self! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 10/4/2009 12:18'!
projectReferenceSpecClass

	^MetacelloProjectReferenceSpec! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 14:54'!
projectSpec

	^self projectSpecClass for: self! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'DaleHenrichs 10/27/2010 11:15'!
projectSpecClass

	^self subclassResponsibility! !

!MetacelloProject methodsFor: 'private' stamp: 'DaleHenrichs 11/10/2010 16:13'!
sortedAndFilteredVersions

		^(self map values asArray sort: [:a :b | a >= b ]) select: [:vrsn | (#(broken baseline) includes: vrsn blessing) not ].
! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 1/17/2011 11:23'!
stableVersion

	^self version: #stable! !

!MetacelloProject methodsFor: 'accessing' stamp: 'DaleHenrichs 9/23/2010 15:26'!
symbolicVersionMap

	^symbolicVersionMap
				
				! !

!MetacelloProject methodsFor: 'accessing' stamp: 'DaleHenrichs 9/23/2010 15:26'!
symbolicVersionMap: aDictionary

	symbolicVersionMap := aDictionary
				
				! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 01/24/2011 13:33'!
symbolicVersionSymbols

	^self symbolicVersionMap keys asArray sort: [:a :b | a <= b ]! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/5/2009 11:47'!
valueHolderSpec

	^self valueHolderSpecClass for: self! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/5/2009 11:47'!
valueHolderSpecClass

	^MetacelloValueHolderSpec! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/18/2010 15:58'!
version: aVersionString
	| vrsn |
	aVersionString isSymbol
		ifTrue: [ 
			| symbolicVersionString |
			symbolicVersionString := self symbolicVersionMap
				at: aVersionString
				ifAbsent: [ (MetacelloSymbolicVersionDoesNotExistError project: self project versionString: aVersionString) signal ].
			symbolicVersionString == #notDefined
				ifTrue: [ (MetacelloSymbolicVersionNotDefinedError project: self project versionString: aVersionString) signal ].
			^ self map
				at: symbolicVersionString
				ifAbsent: [ (MetacelloSymbolicVersionDoesNotExistError project: self project versionString: symbolicVersionString) signal ] ].
	^ self map
		at: aVersionString
		ifAbsent: [ (MetacelloVersionDoesNotExistError project: self project versionString: aVersionString) signal ]! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/2/2010 17:13'!
version: aVersionString ifAbsent: aBlock

	^[ self version: aVersionString ] on: MetacelloVersionDoesNotExistError do: [:ex | aBlock value ].! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 11:00'!
versionSpec

	^self versionSpecClass for: self! !

!MetacelloProject methodsFor: 'spec classes' stamp: 'dkh 6/4/2009 18:51'!
versionSpecClass

	^MetacelloVersionSpec! !

!MetacelloProject methodsFor: 'versions' stamp: 'DaleHenrichs 11/10/2010 16:13'!
versions

	^self map values asArray sort: [:a :b | a <= b ]! !

Object subclass: #MetacelloSpec
	instanceVariableNames: 'project loader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

MetacelloSpec subclass: #MetacelloAbstractPackageSpec
	instanceVariableNames: 'name requires includes answers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloAbstractPackageSpec methodsFor: 'adding' stamp: 'dkh 10/5/2009 12:07'!
addToMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec addMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloAbstractPackageSpec methodsFor: 'querying' stamp: 'dkh 1/4/2010 18:54'!
answers

	answers == nil ifTrue: [ answers := #() ].
	^answers! !

!MetacelloAbstractPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/4/2010 19:01'!
answers: aListOfPairs

	self setAnswers: aListOfPairs! !

!MetacelloAbstractPackageSpec methodsFor: 'printing' stamp: 'DaleHenrichs 1/14/2011 15:09'!
configMethodBodyOn: aStream hasName: hasName cascading: cascading indent: indent

	| hasCascading hasRequires hasIncludes hasAnswers |
	hasCascading := cascading.
	hasRequires := self requires isEmpty not.
	hasIncludes := self includes isEmpty not.
	hasAnswers := self answers isEmpty not.
	hasRequires
		ifTrue: [ 
			hasName | hasIncludes | hasAnswers | hasCascading
				ifTrue: [ aStream cr; tab: indent ].
			aStream nextPutAll: 'requires: #('.
			self requires do: [:str | aStream nextPutAll: str printString, ' ' ].
			hasIncludes | hasAnswers | hasCascading
				ifTrue: [ aStream nextPutAll: ');' ]
				ifFalse: [ aStream nextPut: $) ]].
	hasIncludes
		ifTrue: [ 
			hasName | hasRequires | hasAnswers | hasCascading
				ifTrue: [ aStream cr; tab: indent ].
			aStream nextPutAll: 'includes: #('.
			self includes do: [:str | aStream nextPutAll: str printString, ' ' ].
			hasAnswers | hasCascading
				ifTrue: [ aStream nextPutAll: ');' ]
				ifFalse: [ aStream nextPut: $) ]].
	hasAnswers
		ifTrue: [ 
			hasName | hasRequires | hasIncludes | hasCascading
				ifTrue: [ aStream cr; tab: indent ].
			aStream nextPutAll: 'supplyingAnswers: #( '.
			self answers do: [:ar | 
				aStream nextPutAll: '#( '.
				ar do: [:val | 
					(val isString or: [ val isNumber or: [ val isSymbol or: [ val isCharacter ]]])
						ifTrue: [  aStream nextPutAll: val printString, ' ' ].
					val == true
						ifTrue: [  aStream nextPutAll: 'true ' ].
					val == false
						ifTrue: [  aStream nextPutAll: 'false ' ]].
				aStream nextPutAll: ') ' ].
			hasCascading
				ifTrue: [ aStream nextPutAll: ');' ]
				ifFalse: [ aStream nextPut: $) ]].
! !

!MetacelloAbstractPackageSpec methodsFor: 'printing' stamp: 'dkh 10/5/2009 12:41'!
configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent

	self subclassResponsibility
! !

!MetacelloAbstractPackageSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/21/2010 15:22'!
configMethodOn: aStream for: aValue selector: selector cascading: cascading cascade: cascade indent: indent

	| valuePrintString |
	aValue == nil ifTrue: [ ^self ].
	cascading ifTrue: [ aStream cr; tab: indent ].
	valuePrintString := aValue value isSymbol
		ifTrue: [ '#' , aValue value asString printString ]
		ifFalse: [ aValue value printString ].
	aStream  nextPutAll: selector, valuePrintString.
	cascade ifTrue: [ aStream nextPut: $; ]
! !

!MetacelloAbstractPackageSpec methodsFor: 'querying' stamp: 'dkh 9/23/2009 08:45'!
includes

	includes == nil ifTrue: [ includes := #() ].
	^includes! !

!MetacelloAbstractPackageSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 08:45'!
includes: aCollection

	aCollection setIncludesInMetacelloPackage: self! !

!MetacelloAbstractPackageSpec methodsFor: 'private' stamp: 'dkh 10/10/2009 10:59'!
includesForPackageOrdering

	^#()! !

!MetacelloAbstractPackageSpec methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:33'!
label

	^self name! !

!MetacelloAbstractPackageSpec methodsFor: 'merging' stamp: 'dkh 6/23/2009 11:22'!
mergeIntoMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec mergeMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloAbstractPackageSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 20:36'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #requires put: requires.
	map at: #includes put: includes.
	map at: #answers put: answers.
	^map! !

!MetacelloAbstractPackageSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 20:21'!
mergeSpec: anotherSpec

	| newSpec map anotherRequires anotherIncludes anotherAnswers |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	anotherSpec name ~~ nil 
		ifTrue: [ newSpec name: anotherSpec name ].
	(anotherRequires := map at: #requires) ~~ nil
		ifTrue: [ newSpec setRequires: self requires, anotherRequires ].
	(anotherIncludes := map at: #includes) ~~ nil
		ifTrue: [ newSpec setIncludes: self includes, anotherIncludes ].
	(anotherAnswers := map at: #answers) ~~ nil
		ifTrue: [ newSpec setAnswers: self answers, anotherAnswers ].
	^newSpec
	! !

!MetacelloAbstractPackageSpec methodsFor: 'querying' stamp: 'dkh 6/23/2009 11:24'!
name

	^name! !

!MetacelloAbstractPackageSpec methodsFor: 'accessing' stamp: 'dkh 6/23/2009 11:24'!
name: aString

	name := aString! !

!MetacelloAbstractPackageSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 20:21'!
nonOverridable

	^#( includes requires answers )! !

!MetacelloAbstractPackageSpec methodsFor: 'copying' stamp: 'dkh 1/4/2010 18:55'!
postCopy

	super postCopy.
	requires := requires copy.
	includes := includes copy.
	answers := answers copy.
! !

!MetacelloAbstractPackageSpec methodsFor: 'visiting' stamp: 'dkh 10/5/2009 09:38'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	self subclassResponsibility! !

!MetacelloAbstractPackageSpec methodsFor: 'accessing' stamp: 'dkh 10/24/2009 19:41'!
referencedSpec

	^self! !

!MetacelloAbstractPackageSpec methodsFor: 'removing' stamp: 'dkh 6/23/2009 11:24'!
removeFromMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec removeMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloAbstractPackageSpec methodsFor: 'querying' stamp: 'dkh 6/23/2009 11:25'!
requires

	requires == nil ifTrue: [ requires := #() ].
	^requires! !

!MetacelloAbstractPackageSpec methodsFor: 'accessing' stamp: 'dkh 6/23/2009 11:25'!
requires: aCollection

	aCollection setRequiresInMetacelloPackage: self! !

!MetacelloAbstractPackageSpec methodsFor: 'private' stamp: 'dkh 1/4/2010 18:54'!
setAnswers: aCollection

	answers := aCollection! !

!MetacelloAbstractPackageSpec methodsFor: 'private' stamp: 'dkh 9/23/2009 08:45'!
setIncludes: aCollection

	includes := aCollection! !

!MetacelloAbstractPackageSpec methodsFor: 'private' stamp: 'dkh 6/23/2009 11:25'!
setRequires: aCollection

	requires := aCollection! !

MetacelloAbstractPackageSpec subclass: #MetacelloGroupSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloGroupSpec methodsFor: 'accessing' stamp: 'dkh 1/4/2010 19:02'!
answers: aListOfPairs

	self shouldNotImplement! !

!MetacelloGroupSpec methodsFor: 'printing' stamp: 'dkh 10/24/2009 15:09'!
configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent

	aMember methodUpdateSelector == #remove:
		ifTrue: [ aStream nextPutAll: 'removeGroup: ', self name printString. ]
		ifFalse: [
			aStream 
				nextPutAll: 'group: ', self name printString;
				space; 
				nextPutAll: aMember methodUpdateSelector asString, ' #('.
			self includes do: [:str | aStream nextPutAll: str printString, ' ' ].
			aStream nextPut: $) ].
	lastCascade
		ifTrue: [ aStream nextPut: $. ]
		ifFalse: [ aStream nextPut: $;; cr ].
! !

!MetacelloGroupSpec methodsFor: 'printing' stamp: 'dkh 1/6/2010 18:39'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent;
		nextPutAll: 'spec '; cr;
		tab: indent + 1;
		nextPutAll: 'name: ', self name printString, ';'.
	self configMethodBodyOn: aStream hasName: true cascading: false indent: indent + 1.
	aStream nextPut: $.
! !

!MetacelloGroupSpec methodsFor: 'visiting' stamp: 'dkh 10/5/2009 09:39'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	groupBlock value: self! !

!MetacelloGroupSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 09:41'!
requires: aCollection

	self shouldNotImplement! !

MetacelloAbstractPackageSpec subclass: #MetacelloProjectReferenceSpec
	instanceVariableNames: 'projectReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloProjectReferenceSpec methodsFor: 'accessing' stamp: 'dkh 1/4/2010 19:02'!
answers: aListOfPairs

	self shouldNotImplement! !

!MetacelloProjectReferenceSpec methodsFor: 'printing' stamp: 'DaleHenrichs 11/16/2010 13:52'!
configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent
	aMember methodUpdateSelector == #remove:
		ifTrue: [ aStream nextPutAll: 'removeProject: ' , self name printString ]
		ifFalse: [ 
			self projectReference == nil
				ifTrue: [ ^ self ].
			aStream nextPutAll: 'project: ' , self projectName printString , ' '.
			(aMember methodUpdateSelector == #copy: and: [ self projectReference hasNonVersionStringField ])
				ifTrue: [ aStream nextPutAll: 'copyFrom: ' , aMember sourceName printString , ' ' ].
			self projectReference configShortCutMethodOn: aStream member: aMember indent: indent + 1 ].
	lastCascade
		ifTrue: [ aStream nextPut: $. ]
		ifFalse: [ 
			aStream
				nextPut: $;;
				cr ]! !

!MetacelloProjectReferenceSpec methodsFor: 'printing' stamp: 'dkh 6/25/2011 19:25'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent; nextPutAll: 'spec '; cr;
		tab: indent + 1; nextPutAll: 'name: ', self name printString; nextPut: $;; cr;
		tab: indent + 1; nextPutAll: 'projectReference: '; nextPut: $[; cr.
	aStream 
		tab: indent + 2; nextPutAll: 'spec'.
	self projectReference ifNotNil: [ self projectReference configMethodBodyOn: aStream indent: indent + 2].
	aStream nextPutAll: ' ].'! !

!MetacelloProjectReferenceSpec methodsFor: 'accessing' stamp: 'dkh 10/5/2009 10:13'!
includes: aCollection

	self shouldNotImplement! !

!MetacelloProjectReferenceSpec methodsFor: 'merging' stamp: 'dkh 10/5/2009 11:31'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #projectReference put: projectReference.
	^map! !

!MetacelloProjectReferenceSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 20:00'!
mergeSpec: anotherSpec

	| newSpec map anotherProjectReference |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherProjectReference := map at: #projectReference) ~~ nil
		ifTrue: [ 
			newSpec projectReference: 
				(newSpec projectReference == nil
					ifTrue: [ anotherProjectReference ]
					ifFalse: [ newSpec projectReference mergeSpec: anotherProjectReference ])].
	^newSpec! !

!MetacelloProjectReferenceSpec methodsFor: 'merging' stamp: 'dkh 10/8/2009 20:32'!
nonOverridable

	^super nonOverridable, #( projectReference )! !

!MetacelloProjectReferenceSpec methodsFor: 'copying' stamp: 'DaleHenrichs 11/17/2010 12:43'!
postCopy

	super postCopy.
	projectReference := projectReference copy.
! !

!MetacelloProjectReferenceSpec methodsFor: 'visiting' stamp: 'dkh 10/24/2009 19:43'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	projectBlock value: self! !

!MetacelloProjectReferenceSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 10:51'!
projectName
	^self projectReference name! !

!MetacelloProjectReferenceSpec methodsFor: 'querying' stamp: 'dkh 9/23/2009 10:51'!
projectReference
	^ projectReference! !

!MetacelloProjectReferenceSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 10:51'!
projectReference: anObject
	projectReference := anObject! !

!MetacelloProjectReferenceSpec methodsFor: 'accessing' stamp: 'dkh 10/24/2009 19:42'!
referencedSpec

	^self projectReference! !

!MetacelloProjectReferenceSpec methodsFor: 'querying' stamp: 'DaleHenrichs 2/5/2010 13:42'!
relativeCurrentVersion

	^self projectReference relativeCurrentVersion! !

!MetacelloProjectReferenceSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 11:40'!
requires: aCollection

	self shouldNotImplement! !

!MetacelloProjectReferenceSpec methodsFor: 'querying' stamp: 'dkh 10/24/2009 10:38'!
version

	^self projectReference version! !

!MetacelloProjectReferenceSpec methodsFor: 'querying' stamp: 'DaleHenrichs 11/5/2010 16:00'!
versionOrNil

	^self projectReference versionOrNil! !

!MetacelloProjectReferenceSpec methodsFor: 'querying' stamp: 'DaleHenrichs 11/16/2010 12:41'!
versionString: aString

	^self projectReference versionString: aString! !

MetacelloSpec subclass: #MetacelloMemberListSpec
	instanceVariableNames: 'list memberMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Members'!

!MetacelloMemberListSpec methodsFor: 'actions' stamp: 'dkh 6/5/2012 19:01:24'!
add: aSpec

	self subclassResponsibility! !

!MetacelloMemberListSpec methodsFor: 'adding' stamp: 'dkh 6/5/2012 19:01:24'!
addMember: aMember

	self list add: aMember.
	self clearMemberMap
! !

!MetacelloMemberListSpec methodsFor: 'private' stamp: 'dkh 6/5/2012 19:01:24'!
clearMemberMap

	memberMap := nil.! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
collect: aBlock 
	| newCollection |
	newCollection :=OrderedCollection new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!MetacelloMemberListSpec methodsFor: 'actions' stamp: 'dkh 6/5/2012 19:01:24'!
copy: aMemberSpec

	self addMember: aMemberSpec! !

!MetacelloMemberListSpec methodsFor: 'actions' stamp: 'dkh 6/5/2012 19:01:24'!
copy: specNamed to: aSpec

	self subclassResponsibility! !

!MetacelloMemberListSpec methodsFor: 'toolbox support' stamp: 'dkh 9/12/2012 14:16'!
deleteSpec: aSpec
    "remove the spec from list"

    | member |
    member := self list detect: [ :aMember | aMember spec = aSpec ] ifNone: [ ^ self ].
    self list remove: member! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
detect: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [ self error: 'Object is not in the collection.' ]! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
detect: aBlock ifNone: exceptionBlock
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self
		do: [ :each | 
			(aBlock value: each)
				ifTrue: [ ^ each ] ].
	^ exceptionBlock value! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
do: aBlock

	self map values do: aBlock! !

!MetacelloMemberListSpec methodsFor: 'testing' stamp: 'dkh 6/5/2012 19:01:24'!
isEmpty

	^self list isEmpty! !

!MetacelloMemberListSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
list

	list == nil ifTrue: [ list := OrderedCollection new ].
	^list! !

!MetacelloMemberListSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
list: aCollection

	list := aCollection.
	self clearMemberMap! !

!MetacelloMemberListSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2012 19:01:24'!
map
	
	| map |
	memberMap ~~ nil ifTrue: [ ^memberMap ].
	map := Dictionary new.
	self list do: [:member | 
		member
			applyAdd: [:memberSpec | self mapAdd: memberSpec into: map ] 
			copy: [:memberSpec | self mapCopy: memberSpec into: map ]
			merge: [:memberSpec | self mapMerge: memberSpec into: map ] 
			remove: [:memberSpec | self mapRemove: memberSpec into: map ]].
	memberMap := map.
	^memberMap! !

!MetacelloMemberListSpec methodsFor: 'private' stamp: 'dkh 6/5/2012 19:01:24'!
mapAdd: aMemberSpec into: map
	
	map at: aMemberSpec name put: aMemberSpec spec! !

!MetacelloMemberListSpec methodsFor: 'private' stamp: 'dkh 6/5/2012 19:01:24'!
mapCopy: aMemberSpec into: map
	| spec |
	spec :=  map at: aMemberSpec sourceName ifAbsent: [].
	spec == nil
		ifTrue: [ ^self error: 'Source spec named ',  aMemberSpec sourceName printString, ' not found'. ]
		ifFalse: [ map at: aMemberSpec name put: (spec copy mergeSpec: aMemberSpec spec copy)]! !

!MetacelloMemberListSpec methodsFor: 'private' stamp: 'dkh 6/5/2012 19:01:24'!
mapMerge: aMemberSpec into: map
	| spec |
	spec :=  map at: aMemberSpec name ifAbsent: [].
	spec == nil
		ifTrue: [ map at: aMemberSpec name put: aMemberSpec spec copy ]
		ifFalse: [ map at: aMemberSpec name put: (spec mergeSpec: aMemberSpec spec)]! !

!MetacelloMemberListSpec methodsFor: 'private' stamp: 'dkh 6/5/2012 19:01:24'!
mapRemove: aMemberSpec into: map
	
	map removeKey: aMemberSpec name ifAbsent: []! !

!MetacelloMemberListSpec methodsFor: 'actions' stamp: 'dkh 6/5/2012 19:01:24'!
merge: aSpec

	self subclassResponsibility! !

!MetacelloMemberListSpec methodsFor: 'merging' stamp: 'dkh 6/5/2012 19:01:24'!
mergeSpec: anotherSpec

	| newSpec val |
	newSpec := super mergeSpec: anotherSpec.
	newSpec list: self list copy.
	anotherSpec list do: [:groupMember | groupMember applyToList: newSpec ].
	^newSpec! !

!MetacelloMemberListSpec methodsFor: 'testing' stamp: 'dkh 6/5/2012 19:01:24'!
notEmpty

	^self list notEmpty! !

!MetacelloMemberListSpec methodsFor: 'copying' stamp: 'dkh 6/5/2012 19:01:24'!
postCopy

	super postCopy.
	list := list copy.
	self clearMemberMap! !

!MetacelloMemberListSpec methodsFor: 'actions' stamp: 'dkh 6/5/2012 19:01:24'!
remove: aSpec

	self subclassResponsibility! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
select: aBlock 
	| newCollection |
	newCollection := OrderedCollection new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
specListDetect: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self specListDetect: aBlock ifNone: [ self error: 'Object is not in the collection.' ]! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
specListDetect: aBlock ifNone: exceptionBlock
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self
		specListDo: [ :each | 
			(aBlock value: each)
				ifTrue: [ ^ each ] ].
	^ exceptionBlock value! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
specListDo: aBlock

	self list do: [:member |  aBlock value: member spec ]! !

!MetacelloMemberListSpec methodsFor: 'enumeration' stamp: 'dkh 6/5/2012 19:01:24'!
specListSelect: aBlock 
	| newCollection |
	newCollection := OrderedCollection new.
	self specListDo: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

MetacelloMemberListSpec subclass: #MetacelloPackagesSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloPackagesSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 11:23'!
add: aSpec

	aSpec addToMetacelloPackages: self! !

!MetacelloPackagesSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 7/23/2010 13:24'!
applyIncludesTo: orderedSpecs for: pkgSpec firstTime: firstTime
	| movedSpecs baseIndex includedSpec result |
	movedSpecs := Set new.
	baseIndex := orderedSpecs indexOf: pkgSpec.
	pkgSpec includesForPackageOrdering
		do: [:includedSpecName | 
			includedSpec := orderedSpecs
						detect: [:spec | spec name = includedSpecName ]
						ifNone: [].
			(self slideIn: orderedSpecs spec: includedSpec baseIndex: baseIndex seen: IdentitySet new firstTime: firstTime)
				ifTrue: [ movedSpecs add: includedSpec name ]].
	^ movedSpecs! !

!MetacelloPackagesSpec methodsFor: 'printing' stamp: 'dkh 10/22/2009 10:33'!
configMethodOn: aStream indent: indent

	| packageSpecs |
	packageSpecs := self map values.
	packageSpecs size = 0 ifTrue: [ ^aStream nextPutAll: 'spec add: []' ].
	packageSpecs size = 1
		ifTrue: [
			aStream 
				tab: indent; 
				nextPutAll: 'spec add: ['; cr.
			packageSpecs first configMethodOn: aStream indent: indent + 1.
			aStream nextPut: $]; cr ]
		ifFalse: [
			aStream 
				tab: indent; 
				nextPutAll: 'spec'.
			1 to: packageSpecs size do: [:index | | packageSpec |
				packageSpec := packageSpecs at: index.
				aStream 
					tab: indent + 1;
					nextPutAll: 'add: ['; cr.
				packageSpec configMethodOn: aStream indent: indent + 2.
				aStream nextPut: $].
				index < packageSpecs size
					ifTrue: [ aStream nextPut: $; ].
				aStream cr ]]! !

!MetacelloPackagesSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 11:22'!
copy: specNamed to: spec

	self addMember: 
		(self copyMember 
			name: spec name;
			sourceName: specNamed;
			spec: spec;
			yourself)
! !

!MetacelloPackagesSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 11:23'!
merge: aSpec

	aSpec mergeIntoMetacelloPackages: self! !

!MetacelloPackagesSpec methodsFor: 'accessing' stamp: 'dkh 10/9/2009 13:01'!
packageNamed: aString ifAbsent: aBlock

	^self map at: aString ifAbsent: aBlock! !

!MetacelloPackagesSpec methodsFor: 'accessing' stamp: 'dkh 9/5/2012 05:46'!
packageSpecsInLoadOrder
    | orderedSpecs moved lastMovedSpecs count terminationLimit map specsWithIncludes firstTime |
    "specification order is the default order"
    map := self map.
    orderedSpecs := OrderedCollection new.
    self list
        do: [ :member | 
            | spec |
            spec := map at: member name ifAbsent: [  ].
            (spec == nil or: [ orderedSpecs includes: spec ])
                ifFalse: [ orderedSpecs add: spec ] ].
    orderedSpecs isEmpty
        ifTrue: [ ^ orderedSpecs ].
    moved := true.
    count := 0.
    terminationLimit := orderedSpecs size * 2.
    [ moved ]
        whileTrue: [ 
            count := count + 1.
            count > terminationLimit
                ifTrue: [ 
                    "Cheap termination hack - an APPARENT loop"
                    self error: 'Apparent loop in before/after dependency definitions' ].
            moved := false.
            orderedSpecs
                do: [ :packageSpec | moved := moved or: [ self sortPackageSpecs: orderedSpecs for: packageSpec ] ] ].
    lastMovedSpecs := Set new.
    moved := true.
    count := 0.
    specsWithIncludes := orderedSpecs select: [ :pkgSpec | pkgSpec includesForPackageOrdering isEmpty not ].
    firstTime := true.
    [ moved ]
        whileTrue: [ 
            | result |
            count := count + 1.	"count > terminationLimit"
            count > 14
                ifTrue: [ 
                    "Cheap termination hack - an APPARENT loop"
                    self error: 'Apparent loop in before/after dependency definitions' ].
            moved := false.
            result := Set new.
            specsWithIncludes
                do: [ :packageSpec | result addAll: (self applyIncludesTo: orderedSpecs for: packageSpec firstTime: firstTime) ].
            result size = lastMovedSpecs size
                ifTrue: [ 
                    result
                        do: [ :name | 
                            (lastMovedSpecs includes: name)
                                ifFalse: [ moved := true ] ] ]
                ifFalse: [ moved := true ].
            lastMovedSpecs := result.
            firstTime := false ].
    ^ orderedSpecs! !

!MetacelloPackagesSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 11:23'!
remove: aSpec

	aSpec removeFromMetacelloPackages: self! !

!MetacelloPackagesSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 7/23/2010 13:27'!
slideIn: orderedSpecs spec: targetSpec baseIndex: baseIndex seen: seen firstTime: firstTime
	| targetIndex requires targetRequires targetRequiresIndexes minIndex baseSpec required |

	(seen includes: targetSpec) ifTrue: [ ^false ].
	targetIndex := orderedSpecs indexOf: targetSpec.
	baseIndex >= targetIndex ifTrue: [ ^false ].
	required := false.
	baseSpec := orderedSpecs at: baseIndex.
	baseIndex + 1 to: targetIndex - 1 do: [:index | | spec |
		spec := orderedSpecs at: index.
		(spec requires includes: baseSpec name) ifTrue: [ required := true ]].
	firstTime ifFalse: [ required ifFalse: [ ^false ]].
	requires := targetSpec requires.
	targetRequires := orderedSpecs
				select: [:spec | requires includes: spec name].
	targetRequiresIndexes := targetRequires
				collect: [:spec | orderedSpecs indexOf: spec].
	targetRequiresIndexes add: baseIndex.
	minIndex := targetRequiresIndexes
				detectMax: [:each | each].
	minIndex + 1 < targetIndex
		ifTrue: [
			orderedSpecs remove: targetSpec.
			orderedSpecs add: targetSpec afterIndex: minIndex.
			seen add: targetSpec ]
		ifFalse: [ ^self slideIn: orderedSpecs spec: (orderedSpecs at: minIndex) baseIndex: 1 seen: seen firstTime: firstTime].
	^true
! !

!MetacelloPackagesSpec methodsFor: 'private' stamp: 'dkh 10/10/2009 10:14'!
sortPackageSpecs: orderedSpecs for: packageSpec

	| packageIndex moved movePackage targetPackage targetIndex targetPackages |
	packageIndex := orderedSpecs indexOf: packageSpec.
	moved := movePackage := false.
	targetPackages := packageSpec requires.
	targetPackages do: [:targetPackageName |
		targetPackage := orderedSpecs 
			detect: [:each | each name = targetPackageName ] 
			ifNone: [].
		targetIndex := orderedSpecs indexOf: targetPackage.
		movePackage := movePackage or: [ packageIndex <= targetIndex ]].
	movePackage 
		ifTrue: [
			moved := true.
			orderedSpecs remove: packageSpec ifAbsent: [ ^self error: 'unexpected error removing package' ].
			targetIndex := 0.
			targetPackages do: [:targetPackageName | 
				(targetPackage := orderedSpecs detect: [:each | 
					each name = targetPackageName ] ifNone: []) ~~ nil
						ifTrue: [ targetIndex := targetIndex max: (orderedSpecs indexOf: targetPackage) ]].
			targetIndex == 0
				ifTrue: [ orderedSpecs add: packageSpec beforeIndex: packageIndex ]
				ifFalse: [ orderedSpecs add: packageSpec afterIndex: targetIndex ]].
	^moved! !

MetacelloSpec subclass: #MetacelloMemberSpec
	instanceVariableNames: 'name spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Members'!

MetacelloMemberSpec subclass: #MetacelloAddMemberSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Members'!

!MetacelloAddMemberSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 10:16'!
applyAdd: addBlock copy: copyBlock merge: mergeBlock remove: removeBlock

	addBlock value: self! !

!MetacelloAddMemberSpec methodsFor: 'actions' stamp: 'dkh 06/02/2009 18:26'!
applyToList: aListSpec

	aListSpec add: self! !

!MetacelloAddMemberSpec methodsFor: 'accessing' stamp: 'dkh 10/9/2009 11:43'!
methodUpdateSelector

	^#overrides:! !

MetacelloMemberSpec subclass: #MetacelloCopyMemberSpec
	instanceVariableNames: 'sourceName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Members'!

!MetacelloCopyMemberSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 10:18'!
applyAdd: addBlock copy: copyBlock merge: mergeBlock remove: removeBlock

	copyBlock value: self
! !

!MetacelloCopyMemberSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 10:19'!
applyToList: aListSpec

	aListSpec copy: self! !

!MetacelloCopyMemberSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 10:19'!
methodUpdateSelector

	^#copy:! !

!MetacelloCopyMemberSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 10:35'!
sourceName

	^sourceName! !

!MetacelloCopyMemberSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 10:36'!
sourceName: aString

	sourceName := aString! !

!MetacelloMemberSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 10:15'!
applyAdd: addBlock copy: copyBlock merge: mergeBlock remove: removeBlock

	self subclassResponsibility

! !

!MetacelloMemberSpec methodsFor: 'actions' stamp: 'dkh 06/02/2009 18:25'!
applyToList: aListSpec

	self subclassResponsibility! !

!MetacelloMemberSpec methodsFor: 'printing' stamp: 'dkh 10/5/2009 12:39'!
configMethodCascadeOn: aStream last: lastCascade indent: indent

	self spec 
		configMethodCascadeOn: aStream 
		member: self 
		last: lastCascade 
		indent: indent! !

!MetacelloMemberSpec methodsFor: 'printing' stamp: 'dkh 10/26/2009 13:34'!
configMethodOn: aStream indent: indent

	aStream nextPutAll: self class name asString, ' member: ('.
	self spec configMethodOn: aStream indent: indent.
	aStream nextPutAll: ')'.! !

!MetacelloMemberSpec methodsFor: 'accessing' stamp: 'dkh 6/15/2009 10:27'!
methodUpdateSelector

	^self subclassResponsibility! !

!MetacelloMemberSpec methodsFor: 'accessing' stamp: 'dkh 06/02/2009 16:36'!
name

	^name! !

!MetacelloMemberSpec methodsFor: 'accessing' stamp: 'dkh 06/02/2009 16:36'!
name: aString

	name := aString! !

!MetacelloMemberSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 10:35'!
sourceName

	^self name! !

!MetacelloMemberSpec methodsFor: 'accessing' stamp: 'dkh 06/02/2009 16:50'!
spec

	^spec! !

!MetacelloMemberSpec methodsFor: 'accessing' stamp: 'dkh 06/02/2009 16:50'!
spec: aMetacelloSpec

	spec := aMetacelloSpec! !

MetacelloMemberSpec subclass: #MetacelloMergeMemberSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Members'!

!MetacelloMergeMemberSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 10:16'!
applyAdd: addBlock copy: copyBlock merge: mergeBlock remove: removeBlock

	mergeBlock value: self
! !

!MetacelloMergeMemberSpec methodsFor: 'actions' stamp: 'dkh 6/5/2009 16:06'!
applyToList: aListSpec

	aListSpec merge: self! !

!MetacelloMergeMemberSpec methodsFor: 'accessing' stamp: 'dkh 10/9/2009 11:43'!
methodUpdateSelector

	^#with:! !

MetacelloMemberSpec subclass: #MetacelloRemoveMemberSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Members'!

!MetacelloRemoveMemberSpec methodsFor: 'actions' stamp: 'dkh 10/4/2009 10:16'!
applyAdd: addBlock copy: copyBlock merge: mergeBlock remove: removeBlock

	removeBlock value: self
! !

!MetacelloRemoveMemberSpec methodsFor: 'actions' stamp: 'dkh 06/02/2009 18:27'!
applyToList: aListSpec

	aListSpec remove: self! !

!MetacelloRemoveMemberSpec methodsFor: 'accessing' stamp: 'dkh 6/15/2009 10:27'!
methodUpdateSelector

	^#remove:! !

MetacelloSpec subclass: #MetacelloProjectSpec
	instanceVariableNames: 'name className versionString operator loads preLoadDoIt postLoadDoIt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloProjectSpec methodsFor: 'adding' stamp: 'dkh 10/4/2009 11:51'!
addToMetacelloPackages: aMetacelloPackagesSpec

	| spec |
	spec := (aMetacelloPackagesSpec project projectReferenceSpec)
			name: self name;
			projectReference: self copy;
			yourself.
	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec addMember 
			name: spec name;
			spec: spec;
			yourself)
			
! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'dkh 06/02/2009 20:27'!
className

	^className! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'dkh 06/02/2009 20:31'!
className: aString

	className := aString! !

!MetacelloProjectSpec methodsFor: 'printing' stamp: 'DaleHenrichs 01/16/2011 13:54'!
configMethodBodyOn: aStream indent: indent
	| hasVersionString hasOperator hasProjectPackage hasLoads hasClassName hasPreLoadDoIt hasPostLoadDoIt |
	hasClassName := self className ~~ nil.
	hasVersionString := self versionString ~~ nil.
	hasOperator := operator ~~ nil.
	hasProjectPackage := self projectPackage ~~ nil
		and: [ self projectPackage packageRepository ~~ nil or: [ self projectPackage name ~= self className ] ].
	hasLoads := self loads ~~ nil.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasClassName
		ifTrue: [ 
			hasVersionString | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'className: ' , self className printString.
			hasVersionString | hasPreLoadDoIt | hasPostLoadDoIt | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasVersionString
		ifTrue: [ 
			| vs |
			hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			vs := self versionString.
			aStream nextPutAll: 'versionString: '.
			vs isSymbol
				ifTrue: [ aStream nextPut: $# ].
			aStream nextPutAll: vs asString printString.
			hasPreLoadDoIt | hasPostLoadDoIt | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasPreLoadDoIt
		ifTrue: [ 
			hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'preLoadDoIt: '.
			self preLoadDoIt value isSymbol
				ifTrue: [ 
					aStream 
						nextPut: $#;
						nextPutAll: self preLoadDoIt value asString printString]
				ifFalse: [ aStream nextPutAll: self preLoadDoIt value asString ].
			hasPostLoadDoIt | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasPostLoadDoIt
		ifTrue: [ 
			hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'postLoadDoIt: '.
			self postLoadDoIt value isSymbol
				ifTrue: [ 
					aStream 
						nextPut: $#;
						nextPutAll: self postLoadDoIt value asString printString]
				ifFalse: [ aStream nextPutAll: self postLoadDoIt value asString ].
			hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasOperator
		ifTrue: [ 
			hasClassName | hasVersionString | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'operator: #' , self operator asString printString.
			hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasLoads
		ifTrue: [ 
			hasClassName | hasVersionString | hasOperator | hasProjectPackage | hasPreLoadDoIt | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'loads: #('.
			self loads do: [ :str | aStream nextPutAll: str printString , ' ' ].
			aStream nextPut: $).
			hasProjectPackage
				ifTrue: [ aStream nextPut: $; ] ].
	hasProjectPackage
		ifTrue: [ 
			| hasName hasRepo |
			hasName := self projectPackage name ~= self className.
			hasRepo := self projectPackage packageRepository ~~ nil.
			hasName
				ifTrue: [ 
					hasClassName | hasVersionString | hasOperator | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
						ifTrue: [ 
							aStream
								cr;
								tab: indent + 1 ]
						ifFalse: [ aStream space ].
					aStream nextPutAll: 'file: ' , self projectPackage name printString.
					hasRepo
						ifTrue: [ aStream nextPut: $; ] ].
			hasRepo
				ifTrue: [ 
					| repos |
					repos := self projectPackage repositories.
					repos map values size = 1
						ifTrue: [ 
							hasClassName | hasVersionString | hasOperator | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
								ifTrue: [ 
									aStream
										cr;
										tab: indent + 1 ]
								ifFalse: [ aStream space ].
							self projectPackage packageRepository configMethodCascadeOn: aStream lastCascade: true ]
						ifFalse: [ 
							aStream cr.
							self projectPackage repositories configMethodCascadeOn: aStream indent: indent ] ] ]! !

!MetacelloProjectSpec methodsFor: 'printing' stamp: 'dkh 10/24/2009 19:56'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent;
		nextPutAll: 'spec '; cr;
		tab: indent + 1;
		nextPutAll: 'name: ', self name printString, ';'.
	self configMethodBodyOn: aStream indent: indent.
	aStream nextPut: $.! !

!MetacelloProjectSpec methodsFor: 'printing' stamp: 'DaleHenrichs 1/12/2011 12:28'!
configShortCutMethodOn: aStream member: aMember indent: indent
	| hasVersionString hasOperator hasProjectPackage hasLoads hasClassName hasPreLoadDoIt hasPostLoadDoIt |
	hasClassName := self className ~~ nil.
	hasVersionString := self versionString ~~ nil.
	hasOperator := operator ~~ nil.
	hasProjectPackage := self projectPackage ~~ nil
		and: [ self projectPackage name ~~ nil or: [ self projectPackage packageRepository ~~ nil ] ].
	hasLoads := self loads ~~ nil.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
		ifTrue: [ 
			(aMember methodUpdateSelector == #copy: or: [ aMember methodUpdateSelector == #with: ])
				ifTrue: [ 
					aStream
						nextPutAll: 'with: [';
						cr ]
				ifFalse: [ 
					aStream
						nextPutAll: 'overrides: [';
						cr ].
			aStream
				tab: indent;
				nextPutAll: 'spec'.
			self configMethodBodyOn: aStream indent: indent.
			aStream nextPutAll: ' ]'.
			^ self ].
	hasVersionString
		ifTrue: [ 
			| vs |
			vs := self versionString.
			aStream nextPutAll: 'with: '.
			vs isSymbol
				ifTrue: [ aStream nextPut: $# ].
			aStream nextPutAll: vs asString printString ]! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 12/21/2010 13:44'!
getPostLoadDoIt

	^postLoadDoIt! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 12/21/2010 13:44'!
getPreLoadDoIt

	^preLoadDoIt! !

!MetacelloProjectSpec methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:33'!
label

	^self name! !

!MetacelloProjectSpec methodsFor: 'loading' stamp: 'dkh 6/9/2009 10:16'!
load

	self subclassResponsibility! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'dkh 10/4/2009 12:04'!
loads
	^ loads! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 12:05'!
loads: aCollection

	aCollection setLoadsInMetacelloProject: self! !

!MetacelloProjectSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 19:34'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #name put: name.
	map at: #className put: className.
	map at: #versionString put: versionString.
	map at: #operator put: operator.
	map at: #loads put: loads.
	map at: #preLoadDoIt put: preLoadDoIt.
	map at: #postLoadDoIt put: postLoadDoIt.
	^map! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'dkh 06/02/2009 20:32'!
name

	^name! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'dkh 06/02/2009 20:32'!
name: aString

	name := aString! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'dkh 10/6/2009 15:39'!
operator

	operator == nil ifTrue: [ ^#>= ].
	^ operator! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'dkh 6/14/2009 13:37'!
operator: anObject
	" #= #~= #> #< #>= #<= #~> "
	
	operator := anObject! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 18:15'!
postLoadDoIt

	^postLoadDoIt! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:56'!
postLoadDoIt: anObject

	anObject setPostLoadDoItInMetacelloSpec: self! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 12/21/2010 13:56'!
preLoadDoIt

	^preLoadDoIt! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:56'!
preLoadDoIt: anObject

	anObject setPreLoadDoItInMetacelloSpec: self! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'dkh 10/5/2009 11:47'!
projectPackage

	^nil! !

!MetacelloProjectSpec methodsFor: 'private' stamp: 'dkh 10/4/2009 12:04'!
setLoads: aCollection

	loads := aCollection! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:52'!
setPostLoadDoIt: aSymbol

	postLoadDoIt := aSymbol! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:53'!
setPreLoadDoIt: aSymbol

	preLoadDoIt := aSymbol! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 9/22/2010 13:52'!
versionKey
	"suitable for using as a unique key for the receiver's version in a dictionary"

	^ self version versionKey! !

!MetacelloProjectSpec methodsFor: 'querying' stamp: 'dkh 6/7/2009 09:20'!
versionString
	^ versionString! !

!MetacelloProjectSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 09:20'!
versionString: anObject
	versionString := anObject! !

!MetacelloSpec class methodsFor: 'instance creation' stamp: 'dkh 05/01/2009 12:22'!
for: aVersionMap

	^(self platformClass new)
		for: aVersionMap;
		yourself! !

!MetacelloSpec class methodsFor: 'accessing' stamp: 'dkh 04/22/2009 12:22'!
platformClass

	^self! !

!MetacelloSpec methodsFor: 'spec creation' stamp: 'dkh 06/02/2009 16:54'!
addMember

	^MetacelloAddMemberSpec for: self project! !

!MetacelloSpec methodsFor: 'querying' stamp: 'DaleHenrichs 4/9/2010 12:47'!
answers

	^#()! !

!MetacelloSpec methodsFor: 'printing' stamp: 'dkh 10/5/2009 09:14'!
configMethodOn: aStream

	self configMethodOn: aStream indent: 0

! !

!MetacelloSpec methodsFor: 'printing' stamp: 'dkh 10/5/2009 09:14'!
configMethodOn: aStream indent: indent

	self subclassResponsibility

! !

!MetacelloSpec methodsFor: 'spec creation' stamp: 'dkh 10/4/2009 10:44'!
copyMember

	^MetacelloCopyMemberSpec for: self project! !

!MetacelloSpec methodsFor: 'doits' stamp: 'dkh 12/30/2009 13:17'!
doItBlock: selector

	selector == nil ifTrue: [ ^nil ].
	selector numArgs = 0
		ifTrue: [ ^[ self project configuration perform: selector ] ].
	selector numArgs = 1
		ifTrue: [ ^[:aLoader | self project configuration perform: selector with: aLoader ] ].
	selector numArgs = 2
		ifTrue: [ ^[:aLoader :pkgSpec | self project configuration perform: selector with: aLoader with: pkgSpec ] ].
	^nil
! !

!MetacelloSpec methodsFor: 'initialization' stamp: 'dkh 06/02/2009 18:05'!
for: aProject

	project := aProject! !

!MetacelloSpec methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:33'!
label

	^self printString! !

!MetacelloSpec methodsFor: 'accessing' stamp: 'dkh 6/18/2009 10:30'!
loader

	loader == nil 
		ifTrue: [ | prjctLoader |
			(prjctLoader := self project loader) == nil
				ifTrue: [ self loader: (self project loaderClass on: self) ]
				ifFalse: [ self loader: prjctLoader ]].
	^loader! !

!MetacelloSpec methodsFor: 'accessing' stamp: 'dkh 6/18/2009 09:46'!
loader: aLoader

	"We're interested in propogating the loader state, _except_ for the spec"
	loader := aLoader copy.
	loader spec: self! !

!MetacelloSpec methodsFor: 'merging' stamp: 'dkh 06/04/2009 14:40'!
mergeMap

	^Dictionary new.
! !

!MetacelloSpec methodsFor: 'spec creation' stamp: 'dkh 06/02/2009 16:54'!
mergeMember

	^MetacelloMergeMemberSpec for: self project! !

!MetacelloSpec methodsFor: 'merging' stamp: 'DaleHenrichs 11/27/2010 12:16'!
mergeSpec: aSpec
	| newSpec nonOverridable |
	aSpec class = self class
		ifFalse: [ self error: 'The project spec ', self name printString, ' in project ', self project label, ' has imcompatible specs.' ].
	newSpec := self copy.
	nonOverridable := self nonOverridable.
	aSpec mergeMap
		keysAndValuesDo: [ :key :value | 
			(nonOverridable includes: key)
				ifFalse: [ 
					value ~~ nil
						ifTrue: [ newSpec instVarNamed: key asString put: value ] ] ].
	^ newSpec! !

!MetacelloSpec methodsFor: 'merging' stamp: 'dkh 9/23/2009 11:41'!
nonOverridable

	^#()! !

!MetacelloSpec methodsFor: 'copying' stamp: 'dkh 10/4/2009 18:56'!
postCopy

	super postCopy.
	loader ~~ nil  ifTrue: [ self loader: loader ]! !

!MetacelloSpec methodsFor: 'doits' stamp: 'dkh 12/30/2009 13:20'!
postLoadDoIt
	"noop unless non-nil value returned"

	^nil! !

!MetacelloSpec methodsFor: 'doits' stamp: 'DaleHenrichs 12/21/2010 11:47'!
postLoadDoItBlock

	^self doItBlock: self postLoadDoIt value
! !

!MetacelloSpec methodsFor: 'doits' stamp: 'dkh 12/30/2009 13:20'!
preLoadDoIt
	"noop unless non-nil value returned"
	
	^nil! !

!MetacelloSpec methodsFor: 'doits' stamp: 'DaleHenrichs 12/21/2010 11:49'!
preLoadDoItBlock

	^self doItBlock: self preLoadDoIt value
! !

!MetacelloSpec methodsFor: 'printing' stamp: 'dkh 10/5/2009 11:08'!
printOn: aStream

	self configMethodOn: aStream indent: 0

! !

!MetacelloSpec methodsFor: 'querying' stamp: 'dkh 06/02/2009 14:42'!
project

	^project! !

!MetacelloSpec methodsFor: 'spec creation' stamp: 'dkh 06/02/2009 16:54'!
removeMember

	^MetacelloRemoveMemberSpec for: self project! !

MetacelloSpec subclass: #MetacelloValueHolderSpec
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloValueHolderSpec methodsFor: 'printing' stamp: 'dkh 10/5/2009 12:23'!
configMethodOn: aStream indent: indent

	aStream tab: indent; nextPutAll: 'spec value: ', self value printString! !

!MetacelloValueHolderSpec methodsFor: 'merging' stamp: 'dkh 6/5/2009 11:46'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #value put: value.
	^map! !

!MetacelloValueHolderSpec methodsFor: 'private' stamp: 'dkh 9/13/2009 07:46'!
setAuthorInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setAuthor: self! !

!MetacelloValueHolderSpec methodsFor: 'private' stamp: 'dkh 6/5/2009 10:49'!
setBlessingInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setBlessing: self! !

!MetacelloValueHolderSpec methodsFor: 'private' stamp: 'dkh 6/5/2009 11:54'!
setDescriptionInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setDescription: self! !

!MetacelloValueHolderSpec methodsFor: 'private' stamp: 'DaleHenrichs 12/21/2010 13:54'!
setPostLoadDoItInMetacelloSpec: aMetacelloSpec

	aMetacelloSpec setPostLoadDoIt: self! !

!MetacelloValueHolderSpec methodsFor: 'private' stamp: 'DaleHenrichs 12/21/2010 13:54'!
setPreLoadDoItInMetacelloSpec: aMetacelloSpec

	aMetacelloSpec setPreLoadDoIt: self! !

!MetacelloValueHolderSpec methodsFor: 'private' stamp: 'dkh 9/13/2009 07:47'!
setTimestampInMetacelloVersion: aMetacelloVersionSpec

	aMetacelloVersionSpec setTimestamp: self! !

!MetacelloValueHolderSpec methodsFor: 'querying' stamp: 'dkh 6/5/2009 11:46'!
value
	^ value! !

!MetacelloValueHolderSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2009 11:46'!
value: anObject
	value := anObject! !

MetacelloSpec subclass: #MetacelloVersionSpec
	instanceVariableNames: 'versionString blessing description author timestamp preLoadDoIt postLoadDoIt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Specs'!

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/13/2009 07:42'!
author

	author == nil 
		ifTrue: [
			^self project valueHolderSpec
				value: '';
				yourself].
	^ author! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/13/2009 07:43'!
author: anObject

	anObject setAuthorInMetacelloVersion: self! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 8/26/2009 10:10'!
blessing

	blessing == nil 
		ifTrue: [
			^self project valueHolderSpec
				value: self project defaultBlessing;
				yourself].
	^ blessing! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2009 10:44'!
blessing: anObject

	anObject setBlessingInMetacelloVersion: self! !

!MetacelloVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/23/2010 10:03'!
configMethodOn: aStream for: spec selector: selector last: last indent: indent
	spec == nil
		ifTrue: [ ^ self ].
	aStream
		tab: indent;
		nextPutAll: 'spec ' , selector , ' [';
		cr.
	spec configMethodOn: aStream indent: indent + 1.
	aStream nextPutAll: ' ].'.
	last
		ifFalse: [ aStream cr ]! !

!MetacelloVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/23/2010 14:27'!
configMethodOn: aStream indent: indent

	self configMethodOn: aStream last: true indent: indent! !

!MetacelloVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/23/2010 09:51'!
configMethodOn: aStream last: last indent: indent
	| values lastIndex lastBlock |
	last
		ifTrue: [ 
			"need to calculate last statement with a value"
			values := {(self getBlessing).
			(self getDescription).
			(self getPreLoadDoIt).
			(self getPostLoadDoIt).
			(self getAuthor).
			(self getTimestamp)}.
			1 to: values size do: [ :index | 
				(values at: index) ~~ nil
					ifTrue: [ lastIndex := index ] ].
			lastBlock := [ :arg | arg = lastIndex ] ]
		ifFalse: [ lastBlock := [ :arg | false ] ].
	self
		configMethodValueOn: aStream
		for: self getBlessing
		selector: 'blessing:'
		last: (lastBlock value: 1)
		indent: indent.
	self
		configMethodValueOn: aStream
		for: self getDescription
		selector: 'description:'
		last: (lastBlock value: 2)
		indent: indent.
	self
		configMethodValueOn: aStream
		for: self getPreLoadDoIt
		selector: 'preLoadDoIt:'
		last: (lastBlock value: 3)
		indent: indent.
	self
		configMethodValueOn: aStream
		for: self getPostLoadDoIt
		selector: 'postLoadDoIt:'
		last: (lastBlock value: 4)
		indent: indent.
	self
		configMethodValueOn: aStream
		for: self getAuthor
		selector: 'author:'
		last: (lastBlock value: 5)
		indent: indent.
	self
		configMethodValueOn: aStream
		for: self getTimestamp
		selector: 'timestamp:'
		last: (lastBlock value: 6)
		indent: indent! !

!MetacelloVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/23/2010 09:38'!
configMethodValueOn: aStream for: spec selector: selector last: last indent: indent
	| valuePrintString |
	spec == nil
		ifTrue: [ ^ self ].
	valuePrintString := spec value isSymbol
		ifTrue: [ '#' , spec value asString printString ]
		ifFalse: [ spec value printString ].
	aStream
		tab: indent;
		nextPutAll: 'spec ' , selector , ' ' , valuePrintString , '.'.
	last
		ifFalse: [ aStream cr ]! !

!MetacelloVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/23/2010 09:39'!
configSpawnMethodOn: aStream indent: indent

	self configMethodValueOn: aStream for: self getBlessing selector: 'blessing:' last: false indent: indent.
	self configMethodValueOn: aStream for: self getAuthor selector: 'author:' last: false indent: indent.
	self configMethodValueOn: aStream for: self getTimestamp selector: 'timestamp:' last: false indent: indent.

! !

!MetacelloVersionSpec methodsFor: 'private' stamp: 'dkh 10/7/2009 14:45'!
createVersion

	^self versionClass fromSpec: self! !

!MetacelloVersionSpec methodsFor: 'toolbox support' stamp: 'dkh 9/12/2012 14:26'!
deleteSpec: aSpec
    "remove the spec from packages"

    self packages deleteSpec: aSpec! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 8/26/2009 10:35'!
description

	description == nil 
		ifTrue: [
			^self project valueHolderSpec
				value: '';
				yourself].
	^ description! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2009 11:40'!
description: anObject

	anObject setDescriptionInMetacelloVersion: self! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:42'!
getAuthor
	^author! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:41'!
getBlessing
	^blessing! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:41'!
getDescription
	^description! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 12/30/2009 13:25'!
getPostLoadDoIt
	^postLoadDoIt! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 12/30/2009 13:25'!
getPreLoadDoIt
	^preLoadDoIt! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/3/2009 16:42'!
getTimestamp
	^timestamp! !

!MetacelloVersionSpec methodsFor: 'testing' stamp: 'dkh 12/14/2009 10:20'!
isPartiallyCurrent: notLoadedMatters useEquality: useEquality

	self subclassResponsibility! !

!MetacelloVersionSpec methodsFor: 'testing' stamp: 'dkh 12/14/2009 10:20'!
isPossibleBaseline

	self subclassResponsibility! !

!MetacelloVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:34'!
label

	^self versionString, ' [', self projectLabel, ']'! !

!MetacelloVersionSpec methodsFor: 'merging' stamp: 'dkh 12/30/2009 14:17'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #versionString put: versionString.
	map at: #blessing put: blessing.
	map at: #description put: description.
	map at: #author put: author.
	map at: #timestamp put: timestamp.
	map at: #preLoadDoIt put: preLoadDoIt.
	map at: #postLoadDoIt put: postLoadDoIt.
	^map! !

!MetacelloVersionSpec methodsFor: 'copying' stamp: 'dkh 10/4/2009 19:10'!
postCopy

	super postCopy.
	blessing := blessing copy.
	description := description copy.
	author := author copy.
	timestamp := timestamp copy.
	! !

!MetacelloVersionSpec methodsFor: 'querying' stamp: 'dkh 12/30/2009 13:14'!
postLoadDoIt

	^postLoadDoIt! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:51'!
postLoadDoIt: anObject

	anObject setPostLoadDoItInMetacelloSpec: self! !

!MetacelloVersionSpec methodsFor: 'querying' stamp: 'dkh 12/30/2009 13:15'!
preLoadDoIt

	^preLoadDoIt! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:50'!
preLoadDoIt: anObject

	anObject setPreLoadDoItInMetacelloSpec: self! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:31'!
projectLabel

	^self project label! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/13/2009 07:44'!
setAuthor: anObject
	author := anObject! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2009 10:44'!
setBlessing: anObject
	blessing := anObject! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/5/2009 11:40'!
setDescription: anObject
	description := anObject! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 11:37'!
setPostLoadDoIt: aSymbol

	postLoadDoIt := aSymbol! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 11:37'!
setPreLoadDoIt: aSymbol

	preLoadDoIt := aSymbol! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/13/2009 07:44'!
setTimestamp: anObject
	timestamp := anObject! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/13/2009 07:42'!
timestamp

	timestamp == nil 
		ifTrue: [
			^self project valueHolderSpec
				value: '';
				yourself].
	^ timestamp! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/13/2009 07:44'!
timestamp: anObject

	anObject setTimestampInMetacelloVersion: self! !

!MetacelloVersionSpec methodsFor: 'private' stamp: 'dkh 10/7/2009 14:44'!
versionClass

	^MetacelloVersion! !

!MetacelloVersionSpec methodsFor: 'querying' stamp: 'dkh 8/31/2009 05:10'!
versionString
	versionString == nil ifTrue: [ ^'' ].
	^ versionString! !

!MetacelloVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/4/2009 18:50'!
versionString: anObject
	versionString := anObject! !

Object subclass: #MetacelloSpecLoader
	instanceVariableNames: 'spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Loaders'!

!MetacelloSpecLoader class methodsFor: 'instance creation' stamp: 'dkh 04/23/2009 11:24'!
on: aMetacelloPackagesSpec

	^(self new) 
		spec: aMetacelloPackagesSpec;
		yourself! !

!MetacelloSpecLoader methodsFor: 'actions' stamp: 'dkh 04/23/2009 11:21'!
load

	self subclassResponsibility! !

!MetacelloSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/12/2009 14:17'!
loadType
	"#atomic or #linear"
	
	^self project loadType! !

!MetacelloSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/12/2009 14:17'!
project

	^self spec project! !

!MetacelloSpecLoader methodsFor: 'accessing' stamp: 'dkh 04/23/2009 11:20'!
spec

	^spec! !

!MetacelloSpecLoader methodsFor: 'accessing' stamp: 'dkh 04/23/2009 11:20'!
spec: aMetacelloPackagesSpec

	spec := aMetacelloPackagesSpec! !

!MetacelloSpecLoader methodsFor: 'actions' stamp: 'dkh 04/23/2009 11:48'!
unload

	self subclassResponsibility! !

Object subclass: #MetacelloValidationIssue
	instanceVariableNames: 'configurationClass explanation reasonCode callSite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Validation'!

MetacelloValidationIssue subclass: #MetacelloValidationCriticalWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Validation'!

!MetacelloValidationCriticalWarning commentStamp: '<historical>' prior: 0!
MetacelloValidationCriticalWarning indicates that there is a logical inconsistency that may not be intentional and that could cause incorrect loads!

!MetacelloValidationCriticalWarning methodsFor: 'testing' stamp: 'DaleHenrichs 11/4/2010 12:27'!
isCriticalWarning

	^true! !

!MetacelloValidationCriticalWarning methodsFor: 'accessing' stamp: 'DaleHenrichs 11/4/2010 12:27'!
label

	^'Critical Warning'! !

MetacelloValidationIssue subclass: #MetacelloValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Validation'!

!MetacelloValidationError commentStamp: '<historical>' prior: 0!
MetacelloValidationError indicates that errors are to be expected if an attempt to use the configuration/version is made!

!MetacelloValidationError methodsFor: 'testing' stamp: 'DaleHenrichs 11/3/2010 16:44'!
isError

	^true! !

!MetacelloValidationError methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 16:37'!
label

	^'Error'! !

!MetacelloValidationIssue class methodsFor: 'instance creation' stamp: 'DaleHenrichs 11/30/2010 13:25'!
configurationClass: aClass reasonCode: aSymbol callSite: aCallSite explanation: aString

	^(self new)
		configurationClass: aClass;
		reasonCode: aSymbol;
		callSite: aCallSite;
		explanation: aString;
		yourself! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/20/2010 07:23'!
callSite
	^ callSite! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/20/2010 07:23'!
callSite: anObject
	callSite := anObject! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 10:20'!
configurationClass
	^ configurationClass! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 10:20'!
configurationClass: aClass
	configurationClass := aClass! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 13:57'!
explanation
	^ explanation! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 13:58'!
explanation: aString
	explanation := aString! !

!MetacelloValidationIssue methodsFor: 'testing' stamp: 'DaleHenrichs 11/4/2010 12:27'!
isCritical

	^self isError or: [ self isCriticalWarning ]! !

!MetacelloValidationIssue methodsFor: 'testing' stamp: 'DaleHenrichs 11/4/2010 12:26'!
isCriticalWarning

	^false! !

!MetacelloValidationIssue methodsFor: 'testing' stamp: 'DaleHenrichs 11/3/2010 16:44'!
isError

	^false! !

!MetacelloValidationIssue methodsFor: 'testing' stamp: 'DaleHenrichs 11/3/2010 16:44'!
isWarning

	^false! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 16:37'!
label

	^''! !

!MetacelloValidationIssue methodsFor: 'printing' stamp: 'DaleHenrichs 12/4/2010 10:29'!
printOn: aStream
	aStream
		nextPutAll: self label;
		nextPut: $:;
		space;
		nextPutAll: self explanation.
	self reasonCode ~~ #none
		ifTrue: [ 
			aStream
				space;
				nextPut: ${;
				space;
				nextPutAll: self reasonCode asString;
				space;
				nextPut: $} ].
	(self configurationClass ~~ nil or: [ self callSite ~~ nil ])
		ifTrue: [ 
			aStream
				space;
				nextPut: $[;
				space.
			self configurationClass ~~ nil
				ifTrue: [ 
					aStream
						nextPutAll: self configurationClass name asString;
						space ].
			self callSite ~~ nil
				ifTrue: [ 
					aStream
						nextPutAll: self callSite name asString;
						space ].
			aStream nextPut: $] ]! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 20:36'!
reasonCode

	reasonCode == nil ifTrue: [ reasonCode := #none ].
	^ reasonCode! !

!MetacelloValidationIssue methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 20:32'!
reasonCode: anObject
	reasonCode := anObject! !

MetacelloValidationIssue subclass: #MetacelloValidationWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Core-Validation'!

!MetacelloValidationWarning commentStamp: '<historical>' prior: 0!
MetacelloValidationWarning indicates that there is a logical inconsistency that is not likely to cause any functional problems!

!MetacelloValidationWarning methodsFor: 'testing' stamp: 'DaleHenrichs 11/3/2010 16:45'!
isWarning

	^true! !

!MetacelloValidationWarning methodsFor: 'accessing' stamp: 'DaleHenrichs 11/3/2010 16:37'!
label

	^'Warning'! !

!Object methodsFor: '*metacello-core' stamp: 'dkh 8/13/2009 10:37'!
metacelloIntegerLessThanSelf: anInteger

	^self error: 'Invalid Metacello verson component - should be String or Integer.'! !

!Object methodsFor: '*metacello-core' stamp: 'dkh 8/13/2009 11:22'!
metacelloStringLessThanSelf: anInteger

	^self error: 'Invalid Metacello verson component - should be String or Integer.'! !

!Object methodsFor: '*metacello-core' stamp: 'dkh 8/13/2009 10:20'!
metacelloVersionComponentLessThan: aMetacelloVersonComponent

	^self error: 'Invalid Metacello verson component - should be String or Integer.'! !
MetacelloPlatform initialize!
